﻿Imports Microsoft.VisualBasic
Imports System.Data
Imports System.Data.SqlClient

Public Class Code

    Public Function listarDetallesGrilla(ByVal codigoPresupuestoEncabezado As Integer) As List(Of PresupuestoDetalleEntidadGrilla)
        Dim lista As New List(Of PresupuestoDetalleEntidadGrilla)
        Dim PresupuestoDetalleBL As New presupuestoDetalleBL
        Try
            lista = PresupuestoDetalleBL.ListarDetallesGrilla(codigoPresupuestoEncabezado)
        Catch ex As Exception
            Throw ex
        End Try
        Return lista
    End Function

    Public Function graficoFlujoCajaMensual(idPresupuestoEncabezado As Integer, grafico As Syncfusion.JavaScript.Web.Chart) As DataTable
        Dim tablaGrafico As New DataTable
        Try
            Dim presupuestoDetalleBL As New presupuestoDetalleBL
            tablaGrafico = presupuestoDetalleBL.obtenerFlujoCajaMensual(idPresupuestoEncabezado)
            grafico.DataSource = tablaGrafico
            grafico.DataBind()
            'grafico.Width = "600px"
            grafico.Height = "600px"
        Catch ex As Exception
            Throw ex
        End Try
        Return tablaGrafico
    End Function

    <Serializable> _
    Public Class PresupuestoDetalleEntidadGrilla

        Public Sub New()
        End Sub

        Public Sub New(id As Integer, lote As String, actividad As String, valor As Double)
            Me.id = id
            Me.lote = lote
            Me.actividad = actividad
            Me.valor = valor
        End Sub

        Public Property id() As Integer
            Get
                Return m_id
            End Get
            Set(value As Integer)
                m_id = value
            End Set
        End Property
        Private m_id As Integer
        Public Property lote() As String
            Get
                Return m_lote
            End Get
            Set(value As String)
                m_lote = value
            End Set
        End Property
        Private m_lote As String
        Public Property actividad() As String
            Get
                Return m_actividad
            End Get
            Set(value As String)
                m_actividad = value
            End Set
        End Property
        Private m_actividad As String
        Public Property valor() As Double
            Get
                Return m_valor
            End Get
            Set(value As Double)
                m_valor = value
            End Set
        End Property
        Private m_valor As Double

    End Class

    Public Class PresupuestoDetalleEntidadResult
        Public Property result() As IEnumerable(Of PresupuestoDetalleEntidadGrilla)
            Get
                Return m_result
            End Get
            Set(value As IEnumerable(Of PresupuestoDetalleEntidadGrilla))
                m_result = value
            End Set
        End Property
        Private m_result As IEnumerable(Of PresupuestoDetalleEntidadGrilla)
        Public Property count() As Integer
            Get
                Return m_count
            End Get
            Set(value As Integer)
                m_count = value
            End Set
        End Property
        Private m_count As Integer
    End Class

    Public Class PresupuestoDetalleDAL

        ''' <summary>
        ''' Selecciona datos de detalles para un encabezado de presupuesto
        ''' </summary>
        ''' <param name="idPresupuestoEncabezado">Id del encabezado de presupuesto</param>
        ''' <returns></returns>
        Public Function SeleccionarDetallesPresupuesto(idPresupuestoEncabezado As Integer) As DataTable
            Try
                Dim tabla As New DataTable
                tabla.Columns.Add("id")
                tabla.Columns.Add("lote")
                tabla.Columns.Add("actividad")
                tabla.Columns.Add("valor")
                tabla.AcceptChanges()

                For index = 1 To 11154
                    If index Mod 2 = 0 Then
                        Dim fila As DataRow = tabla.NewRow
                        fila("id") = index
                        fila("lote") = "A" & index.ToString
                        fila("actividad") = "Actividad " & index.ToString
                        fila("valor") = CInt(Math.Ceiling(Rnd() * index)) + 1
                        tabla.Rows.Add(fila)
                    Else
                        Dim fila As DataRow = tabla.NewRow
                        fila("id") = index
                        fila("lote") = "B" & index.ToString
                        fila("actividad") = "Actividad " & index.ToString
                        fila("valor") = CInt(Math.Ceiling(Rnd() * index)) + 1
                        tabla.Rows.Add(fila)
                    End If

                Next

                Dim fila2 As DataRow = tabla.NewRow
                fila2("id") = 1
                fila2("lote") = "A" & 1.ToString
                fila2("actividad") = "Actividad " & 1.ToString
                fila2("valor") = CInt(Math.Ceiling(Rnd() * 1)) + 1
                tabla.Rows.Add(fila2)

                tabla.AcceptChanges()
                Return tabla
            Catch ex As Exception
                Throw ex
            End Try
        End Function

        Public Function obtenerFlujoCajaMensual(idPresupuestoEncabezado As Integer) As DataTable
            Try
                Dim tabla As New DataTable
                tabla.Columns.Add("nombre")
                tabla.Columns.Add("costoLabor")
                tabla.AcceptChanges()

                Dim fila1 As DataRow = tabla.NewRow
                fila1("nombre") = "Enero"
                fila1("costoLabor") = 110.94
                tabla.Rows.Add(fila1)

                Dim fila2 As DataRow = tabla.NewRow
                fila2("nombre") = "Febrero"
                fila2("costoLabor") = 221.13999999999999
                tabla.Rows.Add(fila2)

                Dim fila3 As DataRow = tabla.NewRow
                fila3("nombre") = "Marzo"
                fila3("costoLabor") = 1232.53
                tabla.Rows.Add(fila3)

                Dim fila4 As DataRow = tabla.NewRow
                fila4("nombre") = "Abril"
                fila4("costoLabor") = 1100.6400000000001
                tabla.Rows.Add(fila4)

                Dim fila5 As DataRow = tabla.NewRow
                fila5("nombre") = "Mayo"
                fila5("costoLabor") = 2233.1599999999999
                tabla.Rows.Add(fila5)

                Dim fila6 As DataRow = tabla.NewRow
                fila6("nombre") = "Junio"
                fila6("costoLabor") = 329.92000000000002
                tabla.Rows.Add(fila6)

                Dim fila7 As DataRow = tabla.NewRow
                fila7("nombre") = "Julio"
                fila7("costoLabor") = 561.60000000000002
                tabla.Rows.Add(fila7)

                Dim fila8 As DataRow = tabla.NewRow
                fila8("nombre") = "Agosto"
                fila8("costoLabor") = 233.5
                tabla.Rows.Add(fila8)

                Dim fila9 As DataRow = tabla.NewRow
                fila9("nombre") = "Septiembre"
                fila9("costoLabor") = 1.1000000000000001
                tabla.Rows.Add(fila9)

                Dim fila10 As DataRow = tabla.NewRow
                fila10("nombre") = "Octubre"
                fila10("costoLabor") = 399.39999999999998
                tabla.Rows.Add(fila10)

                Dim fila11 As DataRow = tabla.NewRow
                fila11("nombre") = "Noviembre"
                fila11("costoLabor") = 489.69999999999999
                tabla.Rows.Add(fila11)

                Dim fila12 As DataRow = tabla.NewRow
                fila12("nombre") = "Diciembre"
                fila12("costoLabor") = 1211.8
                tabla.Rows.Add(fila12)

                tabla.AcceptChanges()

                Return tabla
            Catch ex As Exception
                Throw ex
            End Try
        End Function

    End Class

    Public Class presupuestoDetalleBL

        ''' <summary>
        ''' Selecciona datos dinámicamente para la tabla de detalles de presupuesto
        ''' </summary>
        ''' <param name="codigoPresupuestoEncabezado">Código del presupuesto encabezado</param>
        ''' <returns></returns>
        Public Function ListarDetallesGrilla(codigoPresupuestoEncabezado As Integer) As List(Of PresupuestoDetalleEntidadGrilla)
            Dim tablaDetalles As New DataTable("Detalle")
            Dim lista As New List(Of PresupuestoDetalleEntidadGrilla)()
            Try
                Dim myControl As New PresupuestoDetalleDAL()
                tablaDetalles = myControl.SeleccionarDetallesPresupuesto(codigoPresupuestoEncabezado)
                If tablaDetalles.Rows.Count > 0 Then
                    For Each fila As DataRow In tablaDetalles.Rows
                        Dim objeto As New PresupuestoDetalleEntidadGrilla()
                        objeto.id = Integer.Parse(fila("id").ToString())
                        objeto.lote = fila("lote").ToString()
                        objeto.actividad = fila("actividad").ToString()
                        objeto.valor = Double.Parse(fila("valor").ToString())
                        lista.Add(objeto)
                    Next
                End If
            Catch ex As Exception
                Throw ex
            End Try
            Return lista
        End Function

        Public Function obtenerFlujoCajaMensual(idPresupuestoEncabezado As Integer) As DataTable
            Dim tablaFlujoCaja As New DataTable()
            Try
                Dim myClaseDAL = New PresupuestoDetalleDAL()
                tablaFlujoCaja = myClaseDAL.obtenerFlujoCajaMensual(idPresupuestoEncabezado)
                If tablaFlujoCaja.Rows.Count > 0 Then
                    For i As Integer = 0 To tablaFlujoCaja.Rows.Count - 1
                        Dim valor As String = tablaFlujoCaja.Rows(i)("costoLabor").ToString()
                        tablaFlujoCaja.Rows(i)("costoLabor") = String.Format("{0:n2}", valor)
                        tablaFlujoCaja.AcceptChanges()
                    Next
                End If
            Catch ex As Exception
                Throw ex
            End Try
            Return tablaFlujoCaja
        End Function


    End Class

End Class
