﻿function cargarPlanes(tvPlanes, codigoJefe) {
    var planes;
    $.ajax({
        url: "../ServicioValidaciones.asmx/listarPlanesAccionAprobacion",
        type: "POST",
        dataType: "json",
        data: "{codigoJefe:'" + codigoJefe + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            planes = JSON.parse(result.d);
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
        }
    });
    $(tvPlanes).ejTreeView({
        fields: { id: "id", parentId: "idParent", text: "Texto", hasChild: "hasChild", dataSource: planes, expanded: "Expanded" },
        showCheckbox: true,
        //nodeCheck: planesSeleccionados(lblPlanes, lblFechaInicio, lblFechaFin, tvPlanes, gvsDetalles, gvsRecursos, listaPlanes, checkbox),
        //nodeUncheck: planesDesSeleccionados(lblPlanes, lblFechaInicio, lblFechaFin, tvPlanes, gvsDetalles, gvsRecursos, listaPlanes, checkbox)
    });
}

function mostrarFechaInicioPlanes(lblFechaInicio, listaPlanes) {
    var fechaInicio;
    $.ajax({
        url: "../ServicioValidaciones.asmx/fechaInicioPlanes",
        type: "POST",
        dataType: "json",
        data: "{listaPlanes:'" + listaPlanes + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            fechaInicio = result.d;
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
        }
    });

    lblFechaInicio.textContent = fechaInicio;
}

function mostrarFechaFinPlanes(lblFechaFin, listaPlanes) {
    var fechaFin = '';
    $.ajax({
        url: "../ServicioValidaciones.asmx/fechaFinPlanes",
        type: "POST",
        dataType: "json",
        data: "{listaPlanes:'" + listaPlanes + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            fechaFin = result.d;
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
        }
    });

    lblFechaFin.textContent = fechaFin;
}

function cargarDetalles(listaPlanes, gvsDetalles) {
    if (listaPlanes != undefined) {
        if (listaPlanes.length > 0) {
            var detalles;
            $.ajax({
                url: "../ServicioValidaciones.asmx/listarDetallesPlanesAccionAprobacion",
                type: "POST",
                dataType: "json",
                data: "{listaPlanes:'" + listaPlanes + "'}",
                async: false,
                contentType: "application/json; charset=utf-8",
                success: function (result) {
                    detalles = JSON.parse(result.d);
                },
                error: function (e) {
                    alert(JSON.parse(e.responseText).Message);
                }
            });

            var dataManagerDetalles = ej.DataManager(detalles);

            $(gvsDetalles).ejGrid("option", { dataSource: [] });
            $(gvsDetalles).ejGrid({
                dataSource: dataManagerDetalles,
                allowPaging: true,
                allowGrouping: true
            });
        } else {
            var dataManagerDetalles = ej.DataManager(listaPlanes);
            $(gvsDetalles).ejGrid({
                dataSource: dataManagerDetalles,
                allowPaging: true,
                allowGrouping: true
            });
        }
    } else {
        console.log("No entro por estar indefinida");
    }
}

function cargarRecursos(listaPlanes, gvsRecursos) {
    if (listaPlanes.length > 0) {
        var recursos;
        $.ajax({
            url: "../ServicioValidaciones.asmx/listarRecursosPlanesAccionAprobacion",
            type: "POST",
            dataType: "json",
            data: "{listaPlanes:'" + listaPlanes + "'}",
            async: false,
            contentType: "application/json; charset=utf-8",
            success: function (result) {
                recursos = JSON.parse(result.d);
            },
            error: function (e) {
                alert(JSON.parse(e.responseText).Message);
            }
        });

        var dataManagerRecursos = ej.DataManager(recursos);
        $(gvsRecursos).ejGrid("option", { dataSource: [] });

        $(gvsRecursos).ejGrid({
            dataSource: dataManagerRecursos,
            allowPaging: true
        });
    } else {
        var dataManagerRecursos = ej.DataManager(listaPlanes);
        $(gvsRecursos).ejGrid({
            dataSource: dataManagerRecursos,
            allowPaging: true
        });
    }
}

function isNumeric(expression) {
    return (String(expression).search(/^\d+$/) != -1);
}

function limpiarLista(lista) {
    for (i = 0; i < lista.length; i++) {
        if (isNumeric(lista[i]) == false) {
            lista.splice(i, 1);
        }
    }
    return lista;
}

listaPlanesSeleccionados = [];

function planesSeleccionados(lblPlanes, lblFechaInicio, lblFechaFin, tvPlanes, gvsDetalles, gvsRecursos, listaPlanes, checkbox, estado, campoOcultoEstado) {
    var arbol = $(tvPlanes).ejTreeView();
    var lista;
    $(tvPlanes).ejTreeView({
        nodeCheck: function (args) {
            if (estado == "procesar") {
                lista = [];
                listaPlanes = [];
                campoOcultoEstado.value = "";
            }

            if (args.currentCheckedNodes) {
                var nodes = args.currentCheckedNodes;
                for (var i = 0; i < nodes.length; i++) {
                    var plan = nodes[i].nodeText;
                    console.log(plan);
                    listaPlanes.push(plan);
                }
            }

            //var plan = args.value;
            //console.log(plan);
            //listaPlanes.push(plan);
            lista = limpiarLista(listaPlanes);
            limpiarGrilla(gvsRecursos);
            //cargarRecursos(lista, gvsRecursos);
            mostrarFechaInicioPlanes(lblFechaInicio, lista);
            mostrarFechaFinPlanes(lblFechaFin, lista);
            mostrarPlanesSeleccionados(lblPlanes, lista)
            cargarDetalles(lista, gvsDetalles);
        },
    });
    //console.log(lista);
    //cargarDetalles(lista, gvsDetalles);
}

function planesDesSeleccionados(lblPlanes, lblFechaInicio, lblFechaFin, tvPlanes, gvsDetalles, gvsRecursos, listaPlanes, checkbox) {
    var lista;
    $(tvPlanes).ejTreeView({
        nodeUncheck: function (args) {
            var planesRemovidos = [];
            var planRemovido;
            if (args.currentUncheckedNodes) {
                var nodes = args.currentUncheckedNodes;
                for (var i = 0; i < nodes.length; i++) {
                    planRemovido = nodes[i];
                    //console.log(planRemovido);
                    planesRemovidos.push(planRemovido);                    
                }
            }

            for (j = 0; j < planesRemovidos.length; j++) {
                var planRemover = planesRemovidos[j];
                console.log(planRemover);
                //console.log("Valor del plan a borrar " + planRemovido);
                if (isNumeric(planRemover) == true) {
                    for (i = 0; i < listaPlanes.length; i++) {
                        if (listaPlanes[i] == planRemover) {
                            //console.log("Entro a comparacion y borra " + listaPlanes[i] + " contra " + planRemovido);
                            listaPlanes.splice(i, 1);
                        }
                    }
                }
            }

            //console.log("Despues de borrar " + listaPlanes);
            if (listaPlanes.length > 0) {
                lista = limpiarLista(listaPlanes);
            } else {
                lista = listaPlanes;
            }
            limpiarGrilla(gvsRecursos);
            //cargarRecursos(lista, gvsRecursos);
            mostrarFechaInicioPlanes(lblFechaInicio, lista);
            mostrarFechaFinPlanes(lblFechaFin, lista);
            mostrarPlanesSeleccionados(lblPlanes, lista)
            cargarDetalles(lista, gvsDetalles);
        }
    });
    //console.log(lista)
    //cargarDetalles(lista, gvsDetalles);
}

function limpiarGrilla(grilla) {
    $(grilla).ejGrid("option", { dataSource: [] });
}

function mostrarPlanesSeleccionados(lblPlanes, listaPlanes) {
    lblPlanes.textContent = listaPlanes;
}

function obtenerPlanesEmpleadosSuperior(codigoUsuario, tvplanes) {

}

function procesarPlanesAccionAprobados(listaPlanes, tvPlanes, codigoJefe, codigoUsuarioSession, listaPlanesPosterior, gvsDetalles, gvsRecursos, valorEstado, observaciones) {
    var recursos;
    if (valorEstado == "A") {
        $.ajax({
            url: "../ServicioValidaciones.asmx/procesarPlanesAccion",
            type: "POST",
            dataType: "json",
            data: "{listaPlanes:'" + listaPlanes + "', codigoUsuarioSession:'" + codigoUsuarioSession + "', observaciones:'" + observaciones + "', estado:'" + valorEstado + "'}",
            async: false,
            contentType: "application/json; charset=utf-8",
            success: function (result) {
                recursos = result.d;
            },
            error: function (e) {
                alert(JSON.parse(e.responseText).Message);
            }
        });
    } else {
        //En caso de que se rechazen los planes de acción se procede a enviar correo de notificación
        $.ajax({
            url: "../ServicioValidaciones.asmx/enviarCorreoPlanesRechazados",
            type: "POST",
            dataType: "json",
            data: "{listaPlanes:'" + listaPlanes + "', codigoUsuarioSession:'" + codigoUsuarioSession + "', observaciones:'" + observaciones + "', estado:'" + valorEstado + "'}",
            async: false,
            contentType: "application/json; charset=utf-8",
            success: function (result) {
                recursos = result.d;
            },
            error: function (e) {
                alert(JSON.parse(e.responseText).Message);
            }
        });

    }
    listaPlanes = [];
    listaPlanesPosterior = [];
    cargarPlanes(tvPlanes, codigoJefe);
    cargarDetalles(listaPlanesPosterior, gvsDetalles);
    cargarRecursos(listaPlanesPosterior, gvsRecursos);
    return recursos;
}


/* Resumen aprobación planes de acción  */
function numeroActividadesPlanes(listaPlanes) {
    var numeroActividades;
    $.ajax({
        url: "../ServicioValidaciones.asmx/obtenerNumeroActividadesResumen",
        type: "POST",
        dataType: "json",
        data: "{listaPlanes:'" + listaPlanes + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            numeroActividades = result.d;
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
        }
    });
    return numeroActividades;
}

function numeroResponsablesPlanes(listaPlanes) {
    var numeroSupervisores;
    $.ajax({
        url: "../ServicioValidaciones.asmx/obtenerNumeroResponsablesPlanesAccion",
        type: "POST",
        dataType: "json",
        data: "{listaPlanes:'" + listaPlanes + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            numeroSupervisores = result.d;
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
        }
    });
    return numeroSupervisores;
}

function listarRecursosResumen(listaPlanes) {
    var recursos;
    $.ajax({
        url: "../ServicioValidaciones.asmx/listarRecursosPlanesAccionAprobacion",
        type: "POST",
        dataType: "json",
        data: "{listaPlanes:'" + listaPlanes + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            recursos = JSON.parse(result.d);
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
        }
    });
    return recursos;
}