﻿function obtenerDescripcionPorCodigo(idOrigen, idDestino, lista) {
    var campo1 = document.getElementById(idOrigen)
    var campo2 = document.getElementById(idDestino)

    for (var i = 0; i < lista.length; i++) {
        if (campo1.value == lista[i].Codigo) {
            campo2.value = lista[i].Descripcion;
            return;
        }
    }
    notificarFallaValidacion(campo1, 'Código no encontrado', '');
    campo1.focus();
    return false;
}

function validarFormatoFecha(idCampoFecha, formato) {
    var campoFecha = document.getElementById(idCampoFecha)

    //verifica en caso que no se halla digitado nada y se está usando la ayuda no se ejecute la validación
    if ((campoFecha.value == '') || (campoFecha.value == '__/__/____')) {
        campoFecha.focus();
        return false;
    }

    var dateformat = /^(0?[1-9]|1[012])[\/\-](0?[1-9]|[12][0-9]|3[01])[\/\-]\d{4}$/;
    // Match the date format through regular expression  
    if (campoFecha.value.match(dateformat)) {
        //campoFecha.focus();
        //Test which seperator is used '/' or '-'  
        var opera1 = campoFecha.value.split('/');
        var opera2 = campoFecha.value.split('-');
        lopera1 = opera1.length;
        lopera2 = opera2.length;
        // Extract the string into month, date and year  
        if (lopera1 > 1) {
            var pdate = campoFecha.value.split('/');
        }
        else if (lopera2 > 1) {
            var pdate = campoFecha.value.split('-');
        }

        if ((formato == 'mm/dd/yyyy') || (formato == 'mm-dd-yyyy') || (formato == 'MM-dd-yyyy') || (formato == 'MM/dd/yyyy')) {
            var mm = parseInt(pdate[0]);
            var dd = parseInt(pdate[1]);
            var yy = parseInt(pdate[2]);
        } else if ((formato == 'dd/mm/yyyy') || (formato == 'dd-mm-yyyy')) {
            var dd = parseInt(pdate[0]);
            var mm = parseInt(pdate[1]);
            var yy = parseInt(pdate[2]);
        } else {
            notificarFallaValidacion(campoFecha, 'El formato de fecha: ' + formato + ' es inválido o no ha sido definida su validación', '__/__/____');
            return false;
        }

        // Create list of days of a month [assume there is no leap year by default]  
        var ListofDays = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
        if (mm == 1 || mm > 2) {
            if (dd > ListofDays[mm - 1]) {
                notificarFallaValidacion(campoFecha, 'Formato de fecha no válido', '__/__/____');
                return false;
            }
        }
        if (mm == 2) {
            var lyear = false;
            if ((!(yy % 4) && yy % 100) || !(yy % 400)) {
                lyear = true;
            }
            if ((lyear == false) && (dd >= 29)) {
                notificarFallaValidacion(campoFecha, 'Formato de fecha no válido', '__/__/____');
                return false;
            }
            if ((lyear == true) && (dd > 29)) {
                notificarFallaValidacion(campoFecha, 'Formato de fecha no válido', '__/__/____');
                return false;
            }
        }
    }
    else {
        notificarFallaValidacion(campoFecha, 'Formato de fecha no válido', '__/__/____');
        return false;
    }
}

function notificarFallaValidacion(campoFalla, mensaje, valor) {
    alert(mensaje);
    campoFalla.value = valor;
    setTimeout(campoFalla.focus(), 1000);
}

function verificarValorTipoRecurso(idCampoOrigen, IdCampoDestino, idCampoCodigoRecurso, idCampoNombreRecurso, idTipoEmpleado, idTipoEmpleadoFiltrado, valor) {
    var campoOrigen = document.getElementById(idCampoOrigen);
    var campoDestino = document.getElementById(IdCampoDestino);
    var campoCodRecurso = document.getElementById(idCampoCodigoRecurso);
    var campoDescripcionRecurso = document.getElementById(idCampoNombreRecurso);

    //limpa el codigo y la descripción del recurso
    campoCodRecurso.value = '';
    campoDescripcionRecurso.value = '';


    //Verific si e tipo empleado y coloca 1 en el campo cantidad
    if ((campoOrigen.value == idTipoEmpleado) || (campoOrigen.value == idTipoEmpleadoFiltrado)) {
        campoDestino.value = 1;
        campoDestino.disabled = true;
    } else {
        campoDestino.value = '';
        campoDestino.disabled = false;
    }

}

function verificarActividadPlanAnterior(idCodigoActividad, idDescripcionActividad, idRendimiento, idUnidad, lista, cantRecursos, uma, linea, palma) {
    var campoActividad = document.getElementById(idCodigoActividad);
    var campoDescripcion = document.getElementById(idDescripcionActividad);
    var campoRendimiento = document.getElementById(idRendimiento);
    var campoUnidad = document.getElementById(idUnidad);

    //Campos a validar
    var campoUma = document.getElementById(uma);
    var campoLinea = document.getElementById(linea);
    var campoPalma = document.getElementById(palma);

    //limpia cualquier valor que este en los campos
    campoDescripcion.value = '';
    campoRendimiento.value = '';
    campoUnidad.value = '';

    //optiene la lista a partir del nombre de la variable
    myList = eval(lista);

    //busca el codigo de la actividad en la lsta
    for (i = 0; i < myList.length; i++) {
        if (myList[i].Codigo == campoActividad.value) {
            var requiereUma = myList[i].requiereUma;
            var requiereLinea = myList[i].requiereLinea;
            var requierePalma = myList[i].requierePalma;

            var valorLinea = campoLinea.value;
            var valorPalma = campoPalma.value;

            if (campoUma != null) {
                var valorUma = campoUma.value;                
                if (valorUma == "" && requiereUma == "S") {
                    notificarFallaValidacion(campoActividad, "Se requiere uma para registrar la actividad", "");
                }
            }




            campoDescripcion.value = myList[i].Descripcion;
            campoUnidad.textContent = myList[i].Unidad;

            //si hay recursos personas multiplica el rendimento por la cantidad de personas en el plan
            if (cantRecursos > 0) {
                campoRendimiento.value = myList[i].Rendimiento * cantRecursos;
            } else {
                campoRendimiento.value = myList[i].Rendimiento;
            }
            return;
        }
    }

    notificarFallaValidacion(campoActividad, "La actividad con código: [" + campoActividad.value + "], no se encuentra dentro del listado para este Lote o se encuentra inactiva", "");
}

function verificarActividad(idCodigoActividad, idDescripcionActividad, idCampoLote, idCampoUma, idCampoLinea, idCampoPalma, idRendimiento, idUnidad, myList) {
    var campoActividad = document.getElementById(idCodigoActividad);
    var campoDescripcion = document.getElementById(idDescripcionActividad);
    var campoRendimiento = document.getElementById(idRendimiento);
    var campoUnidad = document.getElementById(idUnidad);
    var campoLote = document.getElementById(idCampoLote);
    var campoLinea = document.getElementById(idCampoLinea);
    var campoPalma = document.getElementById(idCampoPalma);

    //limpia cualquier valor que este en los campos
    campoLote.value = '';
    campoLinea.value = '';
    campoPalma.value = '';
    campoDescripcion.value = '';
    campoRendimiento.value = '';
    campoUnidad.value = '';

    //busca el codigo de la actividad en la lsta
    for (i = 0; i < myList.length; i++) {
        if (myList[i].Codigo == campoActividad.value) {
            campoDescripcion.value = myList[i].Descripcion;
            return;
            //    campoUnidad.value = myList[i].Unidad;

            //    //si hay recursos personas multiplica el rendimento por la cantidad de personas en el plan
            //    if (cantRecursos > 0) {
            //        campoRendimiento.value = myList[i].Rendimiento * cantRecursos;
            //    } else {
            //        campoRendimiento.value = myList[i].Rendimiento;
            //    }

        }
    }

    notificarFallaValidacion(campoActividad, "La actividad con código: [" + campoActividad.value + "], no se encuentra dentro del listado para este tipo de plan o se encuentra inactiva", "");
}

function verificarLote(idCampoLote, idCampoUma, idCampoLinea, idCampoPalma, idUnidad, lista) {
    var campoRendimiento = document.getElementById(idRendimiento);
    var campoUnidad = document.getElementById(idUnidad);
    var campoLote = document.getElementById(idCampoLote);
    var campoLinea = document.getElementById(idCampoLinea);
    var campoPalma = document.getElementById(idCampoPalma);
    var campoUma = document.getElementById(idCampoUma);

    //limpia cualquier valor que este en los campos
    campoLote.value = '';
    campoLinea.value = '';
    campoPalma.value = '';
    campoRendimiento.value = '';
    campoUnidad.value = '';

    //limpia campos dependientes
    if (campoUma != undefined) {
        campoUma.value = '';
    }


    //como la lista aun no está cargada cuando se injecta el codigo javascript, se busca la lista en memoria por el nombre
    var myList = eval(lista);

    //busca el codigo de la actividad en la lsta
    for (i = 0; i < myList.length; i++) {
        if (myList[i].Codigo == campoLote.value.toUpperCase()) {
            campoLote.value = campoLote.value.toUpperCase;
            campoUnidad.value = myList[i].Unidad;
            campoRendimiento.value = myList[i].Rendimiento;
            return;
        }
    }

    notificarFallaValidacion(campoActividad, "El Lote con código: [" + campoLote.value + "], no se encuentra dentro del listado para esta actividad", "");
}

function verificarUma(idCampoUma, idCampoLote, lista) {
    var campoUma = document.getElementById(idCampoUma);
    var campoLote = document.getElementById(idCampoLote);
    
    //como la lista aun no está cargada cuando se injecta el codigo javascript, se busca la lista en memoria por el nombre
    var myList = eval(lista);
    //busca el codigo de la actividad en la lsta
    for (i = 0; i < myList.length; i++) {
        if ((myList[i].cod_uma.trim().toUpperCase() == campoUma.value.trim().toUpperCase()) && (myList[i].cod_lote.trim().toUpperCase() == campoLote.value.trim().toUpperCase())) {
            campoUma.value = myList[i].cod_uma.toUpperCase();
            return;
        }
    }

    notificarFallaValidacion(campoUma, "La UMA : [" + campoUma.value + "], no se encuentra dentro del listado para este Lote", "");
}

function isNumeric(expression) {
    return (String(expression).search(/^\d+$/) != -1);
}

function verificarRow() {
    alert("Hola");
}





