﻿function obtenerNombrePorCodigo(idOrigen, idDestino, lista) {
    var campo1 = document.getElementById(idOrigen)
    var campo2 = document.getElementById(idDestino)

    for (var i = 0; i < lista.length; i++) {
        if (campo1.value == lista[i].CODIGO) {
            campo2.value = lista[i].NOMBRE;
            return;
        }
    }
    notificarFallaValidacion(campo1, 'Código no encontrado', '');
    campo1.value = '';
    campo2.value = '';
    return false;
}

function pesoValido(idPeso) {
    var campo1 = document.getElementById(idPeso);
    if (isNumeric(campo1.value)) {
        return;
    } else {
        notificarFallaValidacion(campo1, 'El peso debe ser un valor numérico', '');
    }
}

function placaMayuscula(idPlaca) {
    var campo1 = document.getElementById(idPlaca);
    campo1.value = campo1.value.toUpperCase();
}

function validarLote(idLote, idFecha, lista) {
    var campoLote = document.getElementById(idLote);
    var campoFecha = document.getElementById(idFecha);
    for (var i = 0; i < lista.length; i++) {
        if (campoLote.value.toUpperCase() == lista[i].CODIGO.trim()) {
            campoLote.value = campoLote.value.toUpperCase();
            //campoFecha.focus();
            return;
        }
    }
    notificarFallaValidacion(campoLote, 'Lote no encontrado', '');
    campo.focus();
    return false;
}

function validarLineaEnLote(idLote, idLinea, lista) {
    var campoLote = document.getElementById(idLote);
    var campoLinea = document.getElementById(idLinea);
    for (var i = 0; i < lista.length; i++) {
        if (campoLote.value.toUpperCase() == lista[i].CODIGO.trim()) {
            campoLote.value = campoLote.value.toUpperCase();
            //campoFecha.focus();
            return;
        }
    }
    notificarFallaValidacion(campoLote, 'Lote no encontrado', '');
    campo.focus();
    return false;
}

function validarSiembra(idSiembra, idFecha, lista) {
    var campoSiembra = document.getElementById(idSiembra);
    var campoFecha = document.getElementById(idFecha);
    for (var i = 0; i < lista.length; i++) {
        if (campoSiembra.value.toUpperCase() == lista[i].AÑO.trim()) {
            campoSiembra.value = campoSiembra.value.toUpperCase();
            //campoFecha.focus();
            return;
        }
    }
    notificarFallaValidacion(campoSiembra, 'Siembra no encontrada', '');
    campoSiembra.focus();
    return false;
}

function validarNumero(idCampo) {
    var numero = document.getElementById(idCampo);
    if (!/^([0-9])*$/.test(numero.value)) {
        notificarFallaValidacion(numero, 'El valor ingresado debe ser numérico', numero.value);
    } else {
        return;
    }
}

function validarCampoVacio(idCampo, idLabelCampo) {
    var campo = document.getElementById(idCampo);
    var labelCampo = document.getElementById(idLabelCampo);
    if (campo.toString() == "") {
        notificarFallaValidacion(campo, 'El valor en el campo ' + labelCampo + " no puede estar vacío", '');
    }
}

function verificarValorErradicacion(idCampoOrigen, IdCampoDestino, idCampoFechaErradicacion, erradicada) {
    //Dropdownlist
    var campoOrigen = document.getElementById(idCampoOrigen);
    //Campo fecha erradicación
    var campoDestino = document.getElementById(IdCampoDestino);
    var campoFechaErradicacion = document.getElementById(idCampoFechaErradicacion);
    if (campoOrigen.value != -1) {
        //Si se va a marcar la palma como erradicada
        if (campoOrigen.value == erradicada) {
            campoDestino.disabled = false;
            campoFechaErradicacion.style.display = 'block';
            campoFechaErradicacion.disabled = false;
        } else {
            campoDestino.disabled = true;
            campoDestino.value = '__/__/____';
            campoFechaErradicacion.style.display = 'none';
            campoFechaErradicacion.disabled = true;
        }
    } else {
        notificarFallaValidacion(campoOrigen, "Seleccione una opción para la palma", '--Seleccione--');
    }
}

function validarLote(idLote, idDivMensaje) {
    var datos;
    $.ajax({
        url: "../ServicioValidaciones.asmx/VerificarExisteLote",
        data: "{idLote:'" + idLote + "'}",
        type: "POST",
        dataType: "json",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            datos = result.d;
        },
        error: function (e) {
            $("#" + idDivMensaje).slideToggle("slow").text(JSON.parse(e.responseText).Message);
            $("#" + idDivMensaje).delay(3000).hide('slow');
            $("#" + idDivMensaje).attr("class", "alert fade in alert-danger");
        }
    });
    return datos;
}

function validarBloque(bloque, idDivMensaje) {
    var datos;
    $.ajax({
        url: "../ServicioValidaciones.asmx/VerificarExisteBloque",
        data: "{bloque:'" + bloque + "'}",
        type: "POST",
        dataType: "json",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            datos = result.d;
        },
        error: function (e) {
            $("#" + idDivMensaje).slideToggle("slow").text(JSON.parse(e.responseText).Message);
            $("#" + idDivMensaje).delay(3000).hide('slow');
            $("#" + idDivMensaje).attr("class", "alert fade in alert-danger");
        }
    });
    return datos;
}

function validarSiembra(siembra, idDivMensaje) {
    var datos;
    $.ajax({
        url: "../ServicioValidaciones.asmx/VerificarExisteSiembra",
        data: "{siembra:'" + siembra + "'}",
        type: "POST",
        dataType: "json",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            datos = result.d;
        },
        error: function (e) {
            $("#" + idDivMensaje).slideToggle("slow").text(JSON.parse(e.responseText).Message);
            $("#" + idDivMensaje).delay(3000).hide('slow');
            $("#" + idDivMensaje).attr("class", "alert fade in alert-danger");
        }
    });
    return datos;
}

function validarActividadAreaPlantacion(areaPlantacion, tipoAreaPlantacion, codigoActividad, idDivMensaje) {
    var datos;
    $.ajax({
        url: "../ServicioValidaciones.asmx/validarActividadAreaPlantacion",
        data: "{areaPlantacion:'" + areaPlantacion + "', tipoAreaPlantacion:'" + tipoAreaPlantacion + "', codigoActividad:'" + codigoActividad + "'}",
        type: "POST",
        dataType: "json",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            datos = result.d;
        },
        error: function (e) {
            $("#" + idDivMensaje).slideToggle("slow").text(JSON.parse(e.responseText).Message);
            $("#" + idDivMensaje).delay(3000).hide('slow');
            $("#" + idDivMensaje).attr("class", "alert fade in alert-danger");
        }
    });
    return datos;
}