﻿function cargarGraficosBalance() {

    var precipitaciones = obtenerRegistrosPrecipitaciones();
    // Create the chart
    var chartPrecipitaciones = $('#highstockPrecipitaciones').highcharts('StockChart', {
        chartPrecipitaciones: {
            renderTo: 'highstockPrecipitaciones',
            width: 600
        },
        rangeSelector: {
            selected: 1,
            buttons: [
                {
                    type: 'day',
                    count: 10,
                    text: '10 d'
                }, {
                    type: 'month',
                    count: 1,
                    text: '1 m'
                }, {
                    type: 'month',
                    count: 6,
                    text: '6 m'
                },
                {
                    type: 'ytd',
                    text: 'A a f'
                },
                {
                    type: 'year',
                    count: 1,
                    text: '1 a'
                }, {
                    type: 'all',
                    text: 'Todo'
                }],
            buttonSpacing: 10,
            inputEnabled: false
        },
        title: {
            text: 'Precipitaciones'
        },
        series: [{
            name: 'Precipitacion',
            data: precipitaciones,
            tooltip: {
                valueDecimals: 2
            }
        }]
    });

    var evapotranspiracion = obtenerRegistrosEvapotranspiracion();
    // Create the chart
    var chartEvapotranspiracion = $('#highstockEvapotranspiracion').highcharts('StockChart', {
        chartEvapotranspiracion: {
            renderTo: 'highstockEvapotranspiracion',
            width: $('#tabevapotranspiracion').width()
        },
        rangeSelector: {
            selected: 1,
            buttons: [
                {
                    type: 'day',
                    count: 10,
                    text: '10 d'
                }, {
                    type: 'month',
                    count: 1,
                    text: '1 m'
                }, {
                    type: 'month',
                    count: 6,
                    text: '6 m'
                },
                {
                    type: 'ytd',
                    text: 'A a f'
                },
                {
                    type: 'year',
                    count: 1,
                    text: '1 a'
                }, {
                    type: 'all',
                    text: 'Todo'
                }],
            buttonSpacing: 10,
            inputEnabled: false
        },
        title: {
            text: 'Evapotranspiración'
        },
        series: [{
            name: 'Evapotranspiración',
            data: evapotranspiracion,
            tooltip: {
                valueDecimals: 2
            }
        }]
    });

    var capacidad = obtenerRegistrosCapacidadAlmacenamiento();
    // Create the chart
    var chartCapacidad = $('#highstockCapacidad').highcharts('StockChart', {
        chartCapacidad: {
            renderTo: 'highstockCapacidad',
            width: $('#tabcapacidad').width()
        },
        rangeSelector: {
            selected: 1,
            buttons: [
                {
                    type: 'day',
                    count: 10,
                    text: '10 d'
                }, {
                    type: 'month',
                    count: 1,
                    text: '1 m'
                }, {
                    type: 'month',
                    count: 6,
                    text: '6 m'
                },
                {
                    type: 'ytd',
                    text: 'A a f'
                },
                {
                    type: 'year',
                    count: 1,
                    text: '1 a'
                }, {
                    type: 'all',
                    text: 'Todo'
                }],
            buttonSpacing: 10,
            inputEnabled: false
        },
        title: {
            text: 'Capacidad de almacenamiento'
        },
        series: [{
            name: 'Capacidad de almacenamiento',
            data: capacidad,
            tooltip: {
                valueDecimals: 2
            }
        }]
    });

    var temperaturaPromedio = obtenerRegistrosTemperaturaPromedio();
    // Create the chart
    var chartTemperatura = $('#highstockTemperatura').highcharts('StockChart', {
        chartTemperatura: {
            renderTo: 'highstockTemperatura',
            width: $('#tabtemperatura').width()
        },
        rangeSelector: {
            selected: 1,
            buttons: [
                {
                    type: 'day',
                    count: 10,
                    text: '10 d'
                }, {
                    type: 'month',
                    count: 1,
                    text: '1 m'
                }, {
                    type: 'month',
                    count: 6,
                    text: '6 m'
                },
                {
                    type: 'ytd',
                    text: 'A a f'
                },
                {
                    type: 'year',
                    count: 1,
                    text: '1 a'
                }, {
                    type: 'all',
                    text: 'Todo'
                }],
            buttonSpacing: 10,
            inputEnabled: false
        },
        title: {
            text: 'Temperatura promedio'
        },
        series: [{
            name: 'Temperatura promedio',
            data: temperaturaPromedio,
            tooltip: {
                valueDecimals: 2
            }
        }]
    });

    var humedadPromedio = obtenerRegistrosHumedadPromedio();
    // Create the chart
    var chartHumedad = $('#highstockHumedad').highcharts('StockChart', {
        chartHumedad: {
            renderTo: 'highstockHumedad',
            width: $('#tabtemperatura').width()
        },
        rangeSelector: {
            selected: 1,
            buttons: [
                {
                    type: 'day',
                    count: 10,
                    text: '10 d'
                }, {
                    type: 'month',
                    count: 1,
                    text: '1 m'
                }, {
                    type: 'month',
                    count: 6,
                    text: '6 m'
                },
                {
                    type: 'ytd',
                    text: 'A a f'
                },
                {
                    type: 'year',
                    count: 1,
                    text: '1 a'
                }, {
                    type: 'all',
                    text: 'Todo'
                }],
            buttonSpacing: 10,
            inputEnabled: false
        },
        title: {
            text: 'Humedad promedio'
        },
        series: [{
            name: 'Humedad promedio',
            data: humedadPromedio,
            tooltip: {
                valueDecimals: 2
            }
        }]
    });

    var radiacionSolarPromedio = obtenerRegistrosRadiacionSolarPromedio();
    // Create the chart
    var chartRadiacionSolar = $('#highstockRadiacion').highcharts('StockChart', {
        chartRadiacionSolar: {
            renderTo: 'highstockRadiacion',
            width: $('#tabradiacion').width()
        },
        rangeSelector: {
            selected: 1,
            buttons: [
                {
                    type: 'day',
                    count: 10,
                    text: '10 d'
                }, {
                    type: 'month',
                    count: 1,
                    text: '1 m'
                }, {
                    type: 'month',
                    count: 6,
                    text: '6 m'
                },
                {
                    type: 'ytd',
                    text: 'A a f'
                },
                {
                    type: 'year',
                    count: 1,
                    text: '1 a'
                }, {
                    type: 'all',
                    text: 'Todo'
                }],
            buttonSpacing: 10,
            inputEnabled: false
        },
        title: {
            text: 'Radiación solar promedio'
        },
        series: [{
            name: 'Radiación solar promedio',
            data: radiacionSolarPromedio,
            tooltip: {
                valueDecimals: 2
            }
        }]
    });

    Highcharts.setOptions({
        lang: {
            months: ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'],
            weekdays: ['Domingo', 'Lunes', 'Martes', 'Miercoles', 'Jueves', 'Viernes', 'Sabado'],
            shortMonths: ['Ene', 'Feb', 'Mar', 'Abr', 'May', 'Jun', 'Jul', 'Ago', 'Sep', 'Oct', 'Nov', 'Dic'],
        }
    });
}

function obtenerRegistrosPrecipitaciones() {
    var planes;
    $.ajax({
        url: "../ServicioValidaciones.asmx/obtenerRegistrosPrecipitaciones",
        type: "POST",
        dataType: "json",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            planes = JSON.parse(result.d);
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
        }
    });
    console.log(planes);
    return planes;
}

function obtenerRegistrosTemperaturaPromedio() {
    var planes;
    $.ajax({
        url: "../ServicioValidaciones.asmx/obtenerRegistrosTemperaturaPromedio",
        type: "POST",
        dataType: "json",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            planes = JSON.parse(result.d);
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
        }
    });
    return planes;
}

function obtenerRegistrosHumedadPromedio() {
    var planes;
    $.ajax({
        url: "../ServicioValidaciones.asmx/obtenerRegistrosHumedadPromedio",
        type: "POST",
        dataType: "json",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            planes = JSON.parse(result.d);
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
        }
    });
    return planes;
}

function obtenerRegistrosRadiacionSolarPromedio() {
    var planes;
    $.ajax({
        url: "../ServicioValidaciones.asmx/obtenerRegistrosRadiacionSolarPromedio",
        type: "POST",
        dataType: "json",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            planes = JSON.parse(result.d);
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
        }
    });
    return planes;
}

function obtenerRegistrosEvapotranspiracion() {
    var planes;
    $.ajax({
        url: "../ServicioValidaciones.asmx/obtenerRegistrosEvapotranspiracion",
        type: "POST",
        dataType: "json",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            planes = JSON.parse(result.d);
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
        }
    });
    return planes;
}

function obtenerRegistrosCapacidadAlmacenamiento() {
    var planes;
    $.ajax({
        url: "../ServicioValidaciones.asmx/obtenerRegistrosCapacidadAlmacenamiento",
        type: "POST",
        dataType: "json",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            planes = JSON.parse(result.d);
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
        }
    });
    return planes;
}