﻿function guardarNombreTab(idTab) {
    document.getElementById("TabName").value = idTab;
}

function mostrarPanelPlantilla() {
    $('#modalDescarga').modal('show');
    jQuery("#gvTipoActividad").jqGrid("GridUnload");
    var datos = listarTipoActividades();
    definicionGridTipoActividades(datos, 520, "gvTipoActividad");
}

function listarTipoActividades() {
    var datos = '';
    $.ajax({
        url: "../ServicioValidaciones.asmx/listarTiposActividades",
        type: "POST",
        dataType: "json",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            datos = JSON.parse(result.d);
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
            return false;
        }
    });
    return datos;
}

function definicionGridTipoActividades(datos, anchoGrid, nombreDivGrid) {
    var info = datos;
    var grid = $("#" + nombreDivGrid).jqGrid({
        datastr: info,
        datatype: 'jsonstring',
        height: "150",
        width: anchoGrid,
        rowNum: 100,
        multiselect: true,
        ignoreCase: true,
        //autowidth: true,
        //shrinkToFit: false,
        colNames: ['Id', 'Tipo de actividad'],
        colModel: [
            { label: 'Id', name: 'Id', key: true, hidden: false, width: 50 },
            { label: 'Categoria', name: 'Categoria', hidden: false, width: 450 }
        ],
        caption: "Categorias de las actividades ",
        onSelectRow: function (id) {
            var p = this.p, item = p.data[p._index[id]];
            if (typeof (item.cb) === "undefined") {
                item.cb = true;
            } else {
                item.cb = !item.cb;
            }
        },
        onSelectAll: function (id, status) {
            for (i = 0; i < id.length; i++) {
                var p = this.p, item = p.data[p._index[id[i]]];
                item.cb = status;
            }
        },
        loadComplete: function () {
            var p = this.p, data = p.data, item, $this = $(this), index = p._index, rowid;
            for (rowid in index) {
                if (index.hasOwnProperty(rowid)) {
                    item = data[index[rowid]];
                    if (typeof (item.cb) === "boolean" && item.cb) {
                        $this.jqGrid('setSelection', rowid, false);
                    }
                }
            }
        },
    });
}

function seleccionados() {
    var seleccionados;
    var valor = '';
    $("#hdfOrden").val('');
    $("#hdfTipoActividad").val('');
    var selected = $('#rbtnFiltro input:checked').val();
    if (selected != undefined) {
        $("#hdfOrden").val(selected);
    } else {
        $("#mensaje").slideToggle("slow").text("Debe seleccionar un filtro para la plantilla");
        $("#mensaje").delay(2000).hide('slow');
        return false;
    }
    seleccionados = jQuery("#gvTipoActividad").jqGrid('getGridParam', 'selarrrow');
    if (seleccionados.length > 0) {
        for (i = 0; i < seleccionados.length; i++) {
            var datoFilaSeleccionada = jQuery('#gvTipoActividad').jqGrid('getRowData', seleccionados[i]);
            var id = datoFilaSeleccionada.Id;
            valor = valor + id + ',';
        }
        $("#hdfTipoActividad").val(valor);
    } else {
        $("#mensaje").slideToggle("slow").text("Debe seleccionar al menos un tipo de actividad");
        $("#mensaje").delay(2000).hide('slow');
        return false;
    }
    blockUIForDownload()
}

function mostrarMensaje(mensaje) {
    $('#modalConfirmacion').modal('show'); $('#lblMensaje').text(mensaje);
}

function mostrarPanelOperacionesActividades(idBoton) {
    $('#hdfModoBoton').val(idBoton);
    $('#txtLoteEdicion').focus();
    aplicarPropiedadesModal(idBoton);
    if (idBoton == "btnAdicionar") {
        var datos = '';
        var anio = $('#txtAnio').val();
        $.ajax({
            url: "../ServicioValidaciones.asmx/tablaPlantillaAdicionarLabores",
            data: "{anio:'" + anio + "'}",
            type: "POST",
            dataType: "json",
            async: false,
            contentType: "application/json; charset=utf-8",
            success: function (result) {
                datos = JSON.parse(result.d);
            },
            error: function (e) {
                alert(JSON.parse(e.responseText).Message);
                return false;
            }
        });
        if (datos != "") {
            $('#modalEdicion').modal('show');
            definicionGridDistribucion(datos);
        } else {
            mostrarMensaje("No se tiene periodos para el año del presupuesto");
        }
    } else if (idBoton == "btnModificar") {
        var id = $('#hdfId').val();
        if (id != "") {
            $('#modalEdicion').modal('show');
            $('#txtIdEdicion').val($('#hdfId').val());
            $('#txtLoteEdicion').val($('#hdfLote').val().toUpperCase());
            $('#txtSiembraEdicion').val($('#hdfSiembra').val());
            $('#txtIdActividadEdicion').val($('#hdfIdActividad').val());
            $('#txtActividadEdicion').val($('#hdfActividad').val());
            $('#txtUnidadEdicion').val($('#hdfUnidad').val());

            var idPresupuestoDetalle = $('#hdfId').val();
            var datos = '';
            $.ajax({
                url: "../ServicioValidaciones.asmx/listarDetallesLabor",
                data: "{idPresupuestoDetalleLabor:'-1', idPresupuestoDetalle:'" + idPresupuestoDetalle + "'}",
                type: "POST",
                dataType: "json",
                async: false,
                contentType: "application/json; charset=utf-8",
                success: function (result) {
                    datos = JSON.parse(result.d);
                },
                error: function (e) {
                    alert(JSON.parse(e.responseText).Message);
                    return false;
                }
            });
            definicionGridDistribucion(datos);
        } else {
            mostrarMensaje("No se tiene seleccionado un detalle a editar");
        }
    }
}

function aplicarPropiedadesModal(idBoton) {
    if (idBoton == "btnAdicionar") {
        document.getElementById("lblTipoLabor").className = "descripciones mostrar";
        document.getElementById("lblRendActividad").className = "descripciones mostrar";
        document.getElementById("lblRendActividadLote").className = "descripciones mostrar";
        document.getElementById("ddlTipoPago").className = "form-control input-width-small mostrar";
        document.getElementById("txtRendActividad").className = "form-control input-width-small mostrar";
        document.getElementById("txtRendActividadLote").className = "form-control input-width-small mostrar";
        document.getElementById("divCodigoActividad").className = "col-xs-4 col-md-4 col-lg-4 mostrar";
        document.getElementById("txtCodigoActividadEdicion").className = "form-control input-width-small mostrar";

        $('#txtIdEdicion').val(""); $('#txtLoteEdicion').val("");
        $('#txtSiembraEdicion').val(""); $('#txtCodigoActividadEdicion').val("");
        $('#txtActividadEdicion').val(""); $('#txtUnidadEdicion').val("");
        $('#txtRendActividad').val(""); $('#txtRendActividadLote').val("");

        $("#txtIdEdicion").prop('disabled', false); $("#txtLoteEdicion").prop('disabled', false);
        $("#txtSiembraEdicion").prop('disabled', true); $("#txtIdActividadEdicion").prop('disabled', false);
        $("#txtCodigoActividadEdicion").prop('disabled', false); $("#txtActividadEdicion").prop('disabled', true);
        $("#txtUnidadEdicion").prop('disabled', true); $("#txtTipoLabor").prop('disabled', false);
        $("#txtRendActividad").prop('disabled', false); $("#txtRendActividadLote").prop('disabled', false);
    } else if (idBoton == "btnModificar") {
        $("#txtLoteEdicion").prop('disabled', true); $("#txtSiembraEdicion").prop('disabled', true);
        $("#txtActividadEdicion").prop('disabled', true); $("#txtUnidadEdicion").prop('disabled', true);
        document.getElementById("lblTipoLabor").className = "descripciones ocultar";
        document.getElementById("lblRendActividad").className = "descripciones ocultar";
        document.getElementById("lblRendActividadLote").className = "descripciones ocultar";

        document.getElementById("ddlTipoPago").className = "form-control input-width-small ocultar";
        document.getElementById("txtRendActividad").className = "form-control input-width-small ocultar";
        document.getElementById("txtRendActividadLote").className = "form-control input-width-small ocultar";
        document.getElementById("divCodigoActividad").className = "ocultar";
        document.getElementById("txtCodigoActividadEdicion").className = "form-control input-width-small ocultar";
    }
}

function definicionGridDistribucion(datos) {
    var info = datos;
    jQuery("#gvDistribucion").jqGrid("GridUnload");
    var grid = $("#gvDistribucion").jqGrid({
        datastr: info,
        datatype: 'jsonstring',
        height: 'auto',
        rowNum: 12,
        multiselect: false,
        ignoreCase: true,
        autowidth: true,
        colNames: ['IdDetalleLabor', 'IdDetalle', 'IdPeriodo', 'Periodo', 'CantLabor', 'Tarifa'],
        colModel: [
        { label: 'Id', name: 'idPresupuestoDetalleLabor', key: true, hidden: true, width: 40 },
        {
            label: 'Id', name: 'idPresupuestoDetalle', key: true, hidden: true, width: 40
        },
        {
            label: 'Id', name: 'idPresupuestoPeriodo', key: true, hidden: true, width: 40
        },
        {
            label: 'Periodo', name: 'periodo'
        },
        {
            label: 'CantLabor', name: 'cantidadLabor', editable: true, formatter: 'number'
        },
        {
            label: 'Tarifa', name: 'tarifa', editable: true, formatter: 'number'
        },
        ],
        onSelectRow: function (id) {
            var p = this.p, item = p.data[p._index[id]];
            if (typeof (item.cb) === "undefined") {
                item.cb = true;
            } else {
                item.cb = !item.cb;
            }
        },
        'cellEdit': true,
        'cellsubmit': 'clientArray',
        editurl: 'clientArray',
        loadComplete: function () {
            var p = this.p, data = p.data, item, $this = $(this), index = p._index, rowid;
            for (rowid in index) {
                if (index.hasOwnProperty(rowid)) {
                    item = data[index[rowid]];
                    if (typeof (item.cb) === "boolean" && item.cb) {
                        $this.jqGrid('setSelection', rowid, false);
                    }
                }
            }
        },
    });
}

function filaDetalleSeleccionada(args) {
    var grilla = $('#gvsDetalles').data("ejGrid");
    var data = args.data;
    if (data != undefined) {
        $('#hdfId').val(data.idPresupuestoDetalle);
        $('#hdfLote').val(data.Lote);
        $('#hdfSiembra').val(data.Siembra);
        $('#hdfIdActividad').val(data.IdActividad);
        $('#hdfActividad').val(data.Actividad);
        $('#hdfUnidad').val(data.Unidad);
    }
}

function numeroErroresDistribucion(lista) {
    var error = 0;
    var datos;
    //Se verifican que se tengan datos válidos sin campos en blanco ni cambios no aceptados
    for (i = 0; i < lista.length; i++) {
        rowData = jQuery("#gvDistribucion").getRowData(lista[i]);
        if (rowData.cantidadLabor == "") {
            error = error + 1;
        }
        if (rowData.tarifa == "") {
            error = error + 1;
        }
    }
    return error;
}

function llenarListaDetalles(lista) {
    listaDetalles = [];
    for (j = 0; j < lista.length; j++) {
        row = jQuery("#gvDistribucion").getRowData(lista[j]);
        var detalleNuevo =
        {
            "idPresupuestoDetalleLabor": row.idPresupuestoDetalleLabor,
            "idPresupuestoDetalle": row.idPresupuestoDetalle,
            "idPresupuestoPeriodo": row.idPresupuestoPeriodo,
            "tarifa": row.tarifa,
            "cantidadLabor": row.cantidadLabor,
        };
        listaDetalles.push(detalleNuevo);
    }
    return listaDetalles;
}

function operacionesDistribucion() {
    var idBoton = $("#hdfModoBoton").val();
    if (idBoton == "btnAdicionar") {
        adicionarDistribucion();
    } else if (idBoton == "btnModificar") {
        edicionDistribucion();
    }
}

function refrescarGrillaPresupuestoRegistro() {
    var gridObj = $("#gvsDetalles").data("ejGrid");
    gridObj.refreshContent();
}

function adicionarDistribucion() {
    var lista = jQuery("#gvDistribucion").getDataIDs();
    var error = numeroErroresDistribucion(lista);
    var datos = '';
    //Si no se tienen errores se procede a la edición de los registros
    if (error == 0) {
        var listaDetalles = llenarListaDetalles(lista);
        var listado = JSON.stringify(listaDetalles);
        var presupuesto = $("#txtCodigo").val();
        var lote = $("#txtLoteEdicion").val();
        var idActividad = $("#txtCodigoActividadEdicion").val();
        var tipoPago = $("#ddlTipoPago option:selected").val();
        var rendimientoActividad = $("#txtRendActividad").val();
        var rendimientoActividadLote = $("#txtRendActividadLote").val();

        var registroValido = verificarRelacionRegistroPresupuesto(lote, idActividad, presupuesto);
        if (registroValido.toString() == "False") {
            $.ajax({
                url: "../ServicioValidaciones.asmx/adicionarPresupuestosDetalleLabor",
                data: "{presupuesto:'" + presupuesto + "', lote:'" + lote + "', idActividad:'" + idActividad + "', tipoPago:'" + tipoPago + "', rendimientoActividad:'" + rendimientoActividad + "', rendimientoActividadLote:'" + rendimientoActividadLote + "', listado:'" + listado + "'}",
                type: "POST",
                dataType: "json",
                async: false,
                contentType: "application/json; charset=utf-8",
                success: function (result) {
                    datos = JSON.parse(result.d);
                },
                error: function (e) {
                    $("#mensajeEdicion").slideToggle("slow").text(JSON.parse(e.responseText).Message);
                    $("#mensajeEdicion").delay(3000).hide('slow');
                    $("#mensajeEdicion").attr("class", "alert fade in alert-success");
                    return false;
                }
            });
            if (datos == true) {
                refrescarGrillaPresupuestoRegistro();
                $("#mensajeOperacionesActividades").slideToggle("slow").text("Actividad adicionada correctamente");
                $("#mensajeOperacionesActividades").delay(3000).hide('slow');
                $("#mensajeOperacionesActividades").attr("class", "alert fade in alert-success");
                $('#modalEdicion').modal('hide');
            }
            else {
                $("#mensajeEdicion").slideToggle("slow").text(datos);
                $("#mensajeEdicion").delay(3000).hide('slow');
                $("#mensajeEdicion").attr("class", "alert fade in alert-danger");
                return false;
            }
        } else {
            $("#mensajeEdicion").slideToggle("slow").text("La relación lote - actividad ya se encuentra registrada en este presupuesto");
            $("#mensajeEdicion").delay(3000).hide('slow');
            $("#mensajeEdicion").attr("class", "alert fade in alert-danger");
            return false;
        }
    } else {
        $("#mensajeEdicion").slideToggle("slow").text("Se encuentran errores en la información o se tiene alguna celda para editar, por favor verifique");
        $("#mensajeEdicion").delay(3000).hide('slow');
        $("#mensajeEdicion").attr("class", "alert fade in alert-danger");
        return false;
    }
}

function verificarRelacionRegistroPresupuesto(idLote, idActividad, idPresupuestoEncabezado) {
    var valida = "";
    $.ajax({
        url: "../ServicioValidaciones.asmx/verificarRelacionRegistroPresupuesto",
        data: "{idLote:'" + idLote + "', idActividad:'" + idActividad + "', idPresupuestoEncabezado:'" + idPresupuestoEncabezado + "'}",
        type: "POST",
        dataType: "json",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            valida = result.d;
        },
        error: function (e) {
            $("#mensajeEdicion").slideToggle("slow").text(JSON.parse(e.responseText).Message);
            $("#mensajeEdicion").delay(3000).hide('slow');
            $("#mensajeEdicion").attr("class", "alert fade in alert-success");
            return false;
        }
    });
    return valida;
}

function edicionDistribucion() {
    var lista = jQuery("#gvDistribucion").getDataIDs();
    var error = 0;
    var datos;
    //Se verifican que se tengan datos válidos sin campos en blanco ni cambios no aceptados
    for (i = 0; i < lista.length; i++) {
        rowData = jQuery("#gvDistribucion").getRowData(lista[i]);
        if (rowData.cantidadLabor == "") {
            error = error + 1;
        }
        if (rowData.tarifa == "") {
            error = error + 1;
        }
    }
    //Si no se tienen errores se procede a la edición de los registros
    if (error == 0) {
        listaDetalles = [];
        for (j = 0; j < lista.length; j++) {
            row = jQuery("#gvDistribucion").getRowData(lista[j]);
            var detalleNuevo =
            {
                "idPresupuestoDetalleLabor": row.idPresupuestoDetalleLabor,
                "idPresupuestoDetalle": row.idPresupuestoDetalle,
                "idPresupuestoPeriodo": row.idPresupuestoPeriodo,
                "tarifa": row.tarifa,
                "cantidadLabor": row.cantidadLabor,
            };
            listaDetalles.push(detalleNuevo);
        }
        var listado = JSON.stringify(listaDetalles);

        $.ajax({
            url: "../ServicioValidaciones.asmx/editarPresupuestosDetalleLabor",
            data: "{listado:'" + listado + "'}",
            type: "POST",
            dataType: "json",
            async: false,
            contentType: "application/json; charset=utf-8",
            success: function (result) {
                datos = JSON.parse(result.d);
            },
            error: function (e) {
                $("#mensajeEdicion").slideToggle("slow").text(JSON.parse(e.responseText).Message);
                $("#mensajeEdicion").delay(3000).hide('slow');
                $("#mensajeEdicion").attr("class", "alert fade in alert-success");
                return false;
            }
        });
        if (datos == true) {
            refrescarGrillaPresupuestoRegistro();
            $("#mensajeOperacionesActividades").slideToggle("slow").text("Información actualizada correctamente");
            $("#mensajeOperacionesActividades").delay(3000).hide('slow');
            $("#mensajeOperacionesActividades").attr("class", "alert fade in alert-success");
            $('#modalEdicion').modal('hide');
        }
        else {
            $("#mensajeEdicion").slideToggle("slow").text(datos);
            $("#mensajeEdicion").delay(3000).hide('slow');
            $("#mensajeEdicion").attr("class", "alert fade in alert-danger");
            return false;
        }
    } else {
        $("#mensajeEdicion").slideToggle("slow").text("Se encuentran errores en la información o se tiene alguna celda para editar, por favor verifique");
        $("#mensajeEdicion").delay(3000).hide('slow');
        $("#mensajeEdicion").attr("class", "alert fade in alert-danger");
        return false;
    }
}

function mostrarPanelConfirmacion() {
    $('#modalConfirmacionOperacion').modal('show');
}

function mostrar(campo, valor) {
    if (valor == 0) {
        $("#mensajeCargar").slideToggle("slow").text(campo);
        $("#mensajeCargar").delay(5000).hide('slow');
        $("#mensajeCargar").attr("class", "alert fade in alert-danger");
    } else if (valor == 1) {
        $("#mensajeCargar").slideToggle("slow").text(campo);
        $("#mensajeCargar").delay(5000).hide('slow');
        $("#mensajeCargar").attr("class", "alert fade in alert-success");
    } else if (valor == 2) {
        $("#mensajeCargar").slideToggle("slow").text(campo);
        $("#mensajeCargar").delay(5000).hide('slow');
        $("#mensajeCargar").attr("class", "alert fade in alert-warning");
    }
}

function ocultar() {
    $("#mensajeCargar").hide("slow");
}

function mostrarPanelEliminacion(idBoton) {
    $('#hdfModoBoton').val(idBoton);
    document.getElementById('btnConfirmarEliminacion').disabled = false;
    if (idBoton == "btnEliminar") {
        var id = $('#hdfId').val();
        var lote = $('#hdfLote').val();
        var siembra = $('#hdfSiembra').val();
        var idActividad = $('#hdfIdActividad').val();
        var actividad = $('#hdfActividad').val();

        if (id != "") {
            $('#modalConfirmacionEliminacion').modal('show');
            $('#lblMensajeEliminacion').text("Está seguro de eliminar el detalle con la siguiente información");
            $('#lblMensajeDetalladoEliminacion').text("Lote: " + lote + ", Siembra: " + siembra + ", Actividad: " + actividad);
        } else {
            mostrarMensaje("No se tiene seleccionado un detalle a eliminar");
        }
    } else if (idBoton == "btnEliminarPremisa") {
        var id = $('#hdfIdPremisa').val();
        var premisa = $('#hdfNombrePremisa').val();
        var categoria = $('#hdfNombreCategoriaPremisa').val();
        if (id != "") {
            $('#modalConfirmacionEliminacion').modal('show');
            $('#lblMensajeEliminacion').text("Está seguro de eliminar la premisa con la siguiente informacion con la siguiente información");
            $('#lblMensajeDetalladoEliminacion').text("Premisa: " + premisa + ", Categoria: " + categoria);
        } else {
            mostrarMensaje("No se tiene seleccionado una premisa a eliminar");
        }
    }
}

function operacionEliminacion() {
    var idBoton = $('#hdfModoBoton').val();
    var codigoPresupuesto = $("#txtCodigo").val();
    if (idBoton == "btnEliminar") {
        var codigoDetalle = $("#hdfId").val();
        var datos = '';
        $.ajax({
            url: "../ServicioValidaciones.asmx/eliminarDetallePresupuesto",
            data: "{codigoPlanPeriodoPresupuesto:'" + codigoPresupuesto + "', codigoDetalle:'" + codigoDetalle + "'}",
            type: "POST",
            dataType: "json",
            async: false,
            contentType: "application/json; charset=utf-8",
            success: function (result) {
                datos = JSON.parse(result.d);
            },
            error: function (e) {
                $("#mensajeEliminacion").slideToggle("slow").text(JSON.parse(e.responseText).Message);
                $("#mensajeEliminacion").delay(3000).hide('slow');
                $("#mensajeEliminacion").attr("class", "alert fade in alert-success");
                return false;
            }
        });
        if (datos == true) {
            refrescarGrillaPresupuestoRegistro();
            $("#mensajeOperacionesActividades").slideToggle("slow").text("Registro eliminado correctamente");
            $("#mensajeOperacionesActividades").delay(3000).hide('slow');
            $("#mensajeOperacionesActividades").attr("class", "alert fade in alert-success");
            $('#modalConfirmacionEliminacion').modal('hide');
            $("#hdfId").val("");
        }
        else {
            $("#mensajeEliminacion").slideToggle("slow").text(datos);
            $("#mensajeEliminacion").delay(3000).hide('slow');
            $("#mensajeEliminacion").attr("class", "alert fade in alert-danger");
        }

    } else if (idBoton == "btnEliminarPremisa") {
        var codigoPremisa = $("#hdfIdPremisa").val();
        var datos = '';
        $.ajax({
            url: "../ServicioValidaciones.asmx/eliminarPremisaPresupuesto",
            data: "{codigoPresupuesto:'" + codigoPresupuesto + "', codigoPremisa:'" + codigoPremisa + "'}",
            type: "POST",
            dataType: "json",
            async: false,
            contentType: "application/json; charset=utf-8",
            success: function (result) {
                datos = JSON.parse(result.d);
            },
            error: function (e) {
                $("#mensajeEliminacion").slideToggle("slow").text(JSON.parse(e.responseText).Message);
                $("#mensajeEliminacion").delay(3000).hide('slow');
                $("#mensajeEliminacion").attr("class", "alert fade in alert-success");
                return false;
            }
        });
        if (datos == true) {
            recargarPremisas()
            $("#mensajePremisasGeneral").slideToggle("slow").text("Registro eliminado correctamente");
            $("#mensajePremisasGeneral").delay(3000).hide('slow');
            $("#mensajePremisasGeneral").attr("class", "alert fade in alert-success");
            $('#modalConfirmacionEliminacion').modal('hide');
        }
        else {
            $("#mensajeEliminacion").slideToggle("slow").text(datos);
            $("#mensajeEliminacion").delay(3000).hide('slow');
            $("#mensajeEliminacion").attr("class", "alert fade in alert-danger");
        }
    }
}

function validarLotePresupuestoRegistro() {
    var idLote = $("#txtLoteEdicion").val().toUpperCase();
    var datos = validarLote(idLote, "mensajeEdicion");

    if (datos == "True") {
        obtenerSiembraLote(idLote);
        $("#txtLoteEdicion").val(idLote);
        $("#txtCodigoActividadEdicion").focus();
    } else if (datos == "False") {
        $("#mensajeEdicion").slideToggle("slow").text("El lote " + idLote + " no es válido o se encuentra inactivo");
        $("#mensajeEdicion").delay(3000).hide('slow');
        $("#mensajeEdicion").attr("class", "alert fade in alert-danger");
        $("#txtLoteEdicion").val("");
        $("#txtSiembraEdicion").val("");
        $("#txtLoteEdicion").focus();
    }
}

function obtenerSiembraLote(idLote) {
    var siembra = "";
    $.ajax({
        url: "../ServicioValidaciones.asmx/obtenerSiembraLote",
        data: "{lote:'" + idLote + "'}",
        type: "POST",
        dataType: "json",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            siembra = result.d;
        },
        error: function (e) {
            $("#mensajeEdicion").slideToggle("slow").text(JSON.parse(e.responseText).Message);
            $("#mensajeEdicion").delay(3000).hide('slow');
            $("#mensajeEdicion").attr("class", "alert fade in alert-danger");
        }
    });
    $("#txtSiembraEdicion").val(siembra);
}

function validarActividadPerteneceLotePresupuesto() {
    var idLote = $("#txtLoteEdicion").val();
    var codigoActividad = $("#txtCodigoActividadEdicion").val();
    var nombreActividad = "";
    var unidadActividad = "";
    $.ajax({
        url: "../ServicioValidaciones.asmx/nombreActividadLote",
        data: "{codigoActividad:'" + codigoActividad + "', lote:'" + idLote + "'}",
        type: "POST",
        dataType: "json",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            nombreActividad = result.d;
        },
        error: function (e) {
            $("#mensajeEdicion").slideToggle("slow").text(JSON.parse(e.responseText).Message);
            $("#mensajeEdicion").delay(3000).hide('slow');
            $("#mensajeEdicion").attr("class", "alert fade in alert-danger");
        }
    });

    if (nombreActividad != "") {
        $("#txtActividadEdicion").val(nombreActividad);
        $.ajax({
            url: "../ServicioValidaciones.asmx/unidadActividadLote",
            data: "{codigoActividad:'" + codigoActividad + "', lote:'" + idLote + "'}",
            type: "POST",
            dataType: "json",
            async: false,
            contentType: "application/json; charset=utf-8",
            success: function (result) {
                unidadActividad = result.d;
            },
            error: function (e) {
                $("#mensajeEdicion").slideToggle("slow").text(JSON.parse(e.responseText).Message);
                $("#mensajeEdicion").delay(3000).hide('slow');
                $("#mensajeEdicion").attr("class", "alert fade in alert-danger");
            }
        });

        if (unidadActividad != "") {
            $("#txtUnidadEdicion").val(unidadActividad);
        } else {
            $("#mensajeEdicion").slideToggle("slow").text("La actividad no tiene unidad válida");
            $("#mensajeEdicion").delay(3000).hide('slow');
            $("#mensajeEdicion").attr("class", "alert fade in alert-danger");
            $("#txtCodigoActividadEdicion").focus();
            $("#txtCodigoActividadEdicion").val("");
            $("#txtActividadEdicion").val("");
            $("#txtUnidadEdicion").val("");
        }
    } else {
        $("#mensajeEdicion").slideToggle("slow").text("La actividad no existe, está inactiva o no pertenece al lote");
        $("#mensajeEdicion").delay(3000).hide('slow');
        $("#mensajeEdicion").attr("class", "alert fade in alert-danger");
        $("#txtCodigoActividadEdicion").val("");
        $("#txtActividadEdicion").val("");
        $("#txtUnidadEdicion").val("");
        $("#txtCodigoActividadEdicion").focus();
    }
}

function validarNumeroPresupuesto(idCampo) {
    var numero = document.getElementById(idCampo);
    if (!/^([0-9])*[,]?[0-9]*$/.test(numero.value)) {
        $("#mensajeEdicion").slideToggle("slow").text("El valor ingresado debe ser numérico");
        $("#mensajeEdicion").delay(3000).hide('slow');
        $("#mensajeEdicion").attr("class", "alert fade in alert-danger");
        $("#" + idCampo).val("");
        $("#" + idCampo).focus();
    } else {
        return;
    }
}

//******************************************************************Premisas

function filaPremisaSeleccionada(args) {
    var grilla = $('#gvsPremisas').data("ejGrid");
    var data = args.data;
    if (data != undefined) {
        $('#hdfIdPremisa').val(data.idPresupuestoPremisa);
        $('#hdfNombrePremisa').val(data.nombre);
        $('#hdfDescripcionPremisa').val(data.descripcion);
        $('#hdfNombreCategoriaPremisa').val(data.categoria);
        $('#hdfCategoriaPremisa').val(data.idTipoActividad);
    }
}

function recargarPremisas() {
    var codigoPresupuesto = $('#txtCodigo').val();
    $.ajax({
        url: "../ServicioValidaciones.asmx/listarPremisasPresupuesto",
        data: "{codigoPresupuesto:'" + codigoPresupuesto + "'}",
        type: "POST",
        dataType: "json",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            window.gridData = JSON.parse(result.d);
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
            return false;
        }
    });
    $("#gvsPremisas").ejGrid("option", {
        dataSource: []
    });
    var dataManager = ej.DataManager(window.gridData);
    $("#gvsPremisas").ejGrid({
        dataSource: dataManager,
    });
}

function detallePremisa(args) {
    var grid = $("#gvsPremisas").ejGrid("instance");
    var index = this.element.closest("tr").index();
    var record = grid.getCurrentViewData()[index];
    $("#detallesPremisa").ejDialog("open");
    $("#detallesPremisa_wrapper").css({ 'position': 'fixed' }).css({ 'top': '200px' });

    var idPresupuestoPremisa = record["idPresupuestoPremisa"];
    var nombre = record["nombre"];
    var categoria = record["categoria"];
    var descripcion = record["descripcion"];
    $("#txtNombrePremisaDetalle").val(nombre);
    $("#txtCategoriaPremisaDetalle").val(categoria);
    $("#txtDescripcionPremisaDetalle").val(descripcion);
}

/* -- Nuevos métodos de manejar archivos de premisas -- */
function mostrarPanelArchivosPremisa() {
    $('#modalOperacionesPremisas').modal('show');
    archivosAsociadosPremisa();
}

function archivosAsociadosPremisa() {
    //Se traen los archivos asociados a la premisa seleccionada
    jQuery("#gvArchivosPremisa").jqGrid("GridUnload");
    var datos = '';

    var codigoPremisa = $('#hdfIdPremisa').val();

    $.ajax({
        url: "../ServicioValidaciones.asmx/listarArchivosPremisaPresupuesto",
        type: "POST",
        dataType: "json",
        data: "{codigoPremisa:'" + codigoPremisa + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            datos = JSON.parse(result.d);
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
            return false;
        }
    });

    //Organizar definición de la grilla
    definirEstructuraGrilla(datos)
}

function definirEstructuraGrilla(datos) {
    var info = datos;
    var grid = $("#gvArchivosPremisa").jqGrid({
        datastr: info,
        datatype: 'jsonstring',
        height: "120",
        width: "500",
        rowNum: 100,
        multiselect: true,
        ignoreCase: true,
        //colNames: ['Id', 'Ruta', 'Descargar'],
        colNames: ['Id', 'Ruta'],
        colModel: [
    { label: 'id', name: 'id', key: true, sorttype: "int", hidden: true },
    {
        label: 'Ruta', name: 'Ruta', hidden: false
    }
            //,
            //{
            //    name: 'Descargar', align: 'center', sortable: false, width: 40,
            //    formatter: function () { return "<a href='#'>Descargar</a>"; }
            //}
        ],
        caption: "Archivos",
        gridview: true,
        sortname: "id",
        onSelectRow: function (id) {
            var p = this.p, item = p.data[p._index[id]];
            if (typeof (item.cb) === "undefined") {
                item.cb = true;
            } else {
                item.cb = !item.cb;
            }
        },
        onSelectAll: function (id, status) {
            for (i = 0; i < id.length; i++) {
                var p = this.p, item = p.data[p._index[id[i]]];
                item.cb = status;
            }
        },
        //beforeSelectRow: function (rowid, e) {
        //    var $self = $(this),
        //        $td = $(e.target).closest("td"),
        //        rowid = $td.closest("tr.jqgrow").attr("id"),
        //        iCol = $.jgrid.getCellIndex($td[0]),
        //        cm = $self.jqGrid("getGridParam", "colModel");
        //    if (cm[iCol].name === "Descargar" && e.target.tagName.toUpperCase() === "A") {
        //        //Se llama a la función para descargar el archivo
        //        console.log(rowid);
        //        descargarArchivoPremisa(rowid);
        //        return false; // don't select the row on click
        //    }
        //    return true;
        //},
        loadComplete: function () {
            var p = this.p, data = p.data, item, $this = $(this), index = p._index, rowid;
            for (rowid in index) {
                if (index.hasOwnProperty(rowid)) {
                    item = data[index[rowid]];
                    if (typeof (item.cb) === "boolean" && item.cb) {
                        $this.jqGrid('setSelection', rowid, false);
                    }
                }
            }
        },
    });
}

function seleccionarArchivosDescargar() {
    var seleccionados;
    var valor = '';
    seleccionados = jQuery("#gvArchivosPremisa").jqGrid('getGridParam', 'selarrrow');
    try {
        if (seleccionados.length > 0) {
            for (i = 0; i < seleccionados.length; i++) {
                var datoFilaSeleccionada = jQuery('#gvArchivosPremisa').jqGrid('getRowData', seleccionados[i]);
                var id = datoFilaSeleccionada.Ruta;
                valor = valor + id + ',';
            }
            $("#hdfIdArchivosDescargar").val(valor);
        } else {
            $("#mensajePremisas").slideToggle("slow").text("Debe seleccionar al menos un archivo a descargar");
            $("#mensajePremisas").delay(2000).hide('slow');
            return false;
        }
    } catch (ex) {
        $("#mensajePremisas").slideToggle("slow").text(ex.message);
        $("#mensajePremisas").delay(2000).hide('slow');
        return false;
    }
}

function subirArchivoPremisa() {
    var data = new FormData();
    var files = $("#fuArchivoPremisa").get(0).files;
    // Si se tiene archivo se va a guardar
    if (files.length > 0) {
        data.append("ArchivosPremisas", files[0]);
    }
    var ruta = '';
    // Make Ajax request with the contentType = false, and procesDate = false
    var ajaxRequest = $.ajax({
        type: "POST",
        url: "../ServicioValidaciones.asmx/subirArchivoPremisas",
        contentType: false,
        processData: false,
        data: data,
        success: function (result) {
            ruta = result;
        },
    });
    ajaxRequest.done(function (xhr, textStatus) {
        //Si se ha guardado el archivo correctamente, se procede a guardar el registro en la base de datos
        $("#fuArchivoPremisa").replaceWith($("#fuArchivoPremisa").clone());
        //Proceso para guardar el registro en la base de datos
        var codigoPremisa = $("#hdfIdPremisa").val();
        var rutaArchivoPremisa = "C:/Roimer/" + files[0].name;
        var respuestaGuardado = guardarArchivosPremisa(codigoPremisa, rutaArchivoPremisa);
        if (respuestaGuardado == true) {
            archivosAsociadosPremisa();
        }
    });
}

function guardarArchivosPremisa(codigoPremisa, rutaArchivoPremisa) {
    var datos = '';
    $.ajax({
        url: "../ServicioValidaciones.asmx/guardarArchivosPremisaPresupuesto",
        type: "POST",
        data: "{codigoPremisa:'" + codigoPremisa + "', rutaArchivoPremisa:'" + rutaArchivoPremisa + "'}",
        dataType: "json",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            datos = JSON.parse(result.d);
        },
        error: function (e) {
            $("#mensajePremisas").slideToggle("slow").text(JSON.parse(e.responseText).Message);
            $("#mensajePremisas").delay(3000).hide('slow');
            $("#mensajePremisas").attr("class", "alert fade in alert-danger");
            return false;
        }
    });
    if (datos == true) {
        $("#mensajePremisas").slideToggle("slow").text("Archivos asociados correctamente");
        $("#mensajePremisas").delay(3000).hide('slow');
        $("#mensajePremisas").attr("class", "alert fade in alert-success");
    }
    return datos;
}

function eliminarArchivosPremisa() {
    var datos = '';
    var seleccionados;
    var listaDetalles = [];
    var codigoPremisa = $("#hdfIdPremisa").val();
    seleccionados = jQuery("#gvArchivosPremisa").jqGrid('getGridParam', 'selarrrow');
    if (seleccionados.length > 0) {
        var listaArchivos = listadoArchivosPremisaEliminar(seleccionados);
        $.ajax({
            url: "../ServicioValidaciones.asmx/eliminarArchivosPremisaPresupuesto",
            type: "POST",
            data: "{codigoPremisa:'" + codigoPremisa + "', listaArchivos:'" + listaArchivos + "'}",
            dataType: "json",
            async: false,
            contentType: "application/json; charset=utf-8",
            success: function (result) {
                datos = JSON.parse(result.d);
            },
            error: function (e) {
                $("#mensajePremisas").slideToggle("slow").text(JSON.parse(e.responseText).Message);
                $("#mensajePremisas").delay(3000).hide('slow');
                $("#mensajePremisas").attr("class", "alert fade in alert-danger");
                return false;
            }
        });

        if (datos == true) {
            $("#mensajePremisas").slideToggle("slow").text("Archivos eliminados correctamente");
            $("#mensajePremisas").delay(3000).hide('slow');
            $("#mensajePremisas").attr("class", "alert fade in alert-success");
            archivosAsociadosPremisa();
        }
    } else {
        $("#mensajePremisas").slideToggle("slow").text("Debe seleccionar al menos un archivo a eliminar");
        $("#mensajePremisas").delay(3000).hide('slow');
        $("#mensajePremisas").attr("class", "alert fade in alert-danger");
    }
}

function listadoArchivosPremisaEliminar(seleccionados) {
    var lista = '';
    var listaDetalles = [];
    for (i = 0; i < seleccionados.length; i++) {
        var datoFilaSeleccionada = jQuery('#gvArchivosPremisa').jqGrid('getRowData', seleccionados[i]);
        var id = datoFilaSeleccionada.id;
        var ruta = datoFilaSeleccionada.Ruta;
        var detalleNuevo =
        {
            "id": id,
            "Ruta": ruta.replace(/\\/g, "/")
        }
        listaDetalles.push(detalleNuevo);
    }
    lista = JSON.stringify(listaDetalles);
    return lista;
}

function salirPanelGuardarArchivosPremisa() {
    $('#modalOperacionesPremisas').modal('hide');
    //Se limpian los elementos utilizados
    codigo = 1;
    listaDetalles = [];
    $("#txtNombrePremisa").val("");
    $("#txtDescripcionPremisa").val("");
    $("#fuArchivoPremisa").replaceWith($("#fuArchivoPremisa").clone());
}

/* -- Nuevos métodos de manejar archivos de premisas -- */

function eliminarPremisa() {
    var codigoPresupuesto = $("#txtCodigo").val();
    var codigoPremisa = $("#hdfIdPremisa").val();

    $.ajax({
        url: "../ServicioValidaciones.asmx/eliminarPremisaPresupuesto",
        data: "{codigoPresupuesto:'" + codigoPresupuesto + "', codigoPremisa:'" + codigoPremisa + "'}",
        type: "POST",
        dataType: "json",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            datos = JSON.parse(result.d);
        },
        error: function (e) {
            $("#mensajePremisasGeneral").slideToggle("slow").text(JSON.parse(e.responseText).Message);
            $("#mensajePremisasGeneral").delay(3000).hide('slow');
            $("#mensajePremisasGeneral").attr("class", "alert fade in alert-success");
            return false;
        }
    });
    if (datos == true) {
        $("#mensajePremisasGeneral").slideToggle("slow").text("Registro eliminado correctamente");
        $("#mensajePremisasGeneral").delay(3000).hide('slow');
        $("#mensajePremisasGeneral").attr("class", "alert fade in alert-success");
    }
    else {
        $("#mensajePremisasGeneral").slideToggle("slow").text(datos);
        $("#mensajePremisasGeneral").delay(3000).hide('slow');
        $("#mensajePremisasGeneral").attr("class", "alert fade in alert-danger");
    }
}

/********************************************************** Planeación **********************************************************/
function cargarPeriodosPresupuesto() {
    var presupuesto = $('#ddlEscenario').val();
    $.ajax({
        type: "POST",
        url: "/ServicioValidaciones.asmx/cargarPeriodosPresupuesto",
        data: "{presupuesto: '" + presupuesto + "'}",
        contentType: "application/json; charset=utf-8",
        dataType: "json",
        success: function (response) {
            document.getElementById('ddlPeriodo').innerHTML = "";
            var models = (typeof response.d) == 'string' ? eval('(' + response.d + ')') : response.d;
            if (models.length > 0) {
                adicionarOpcion("--Seleccione--", 0, "ddlPeriodo");
                for (var i = 0; i < models.length; i++) {
                    var val = models[i].idPresupuestoPeriodo;
                    var text = models[i].nombre;
                    adicionarOpcion(text, val, "ddlPeriodo");
                }
            } else {
                adicionarOpcion("--Seleccione--", 0, "ddlPeriodo");
            }

        }
    });
}

function adicionarOpcion(text, value, idDropdown) {
    var ddl = document.getElementById(idDropdown);
    var option = document.createElement('option');
    option.value = value;
    option.innerHTML = text;
    ddl.options.add(option);
}

function guardarPeriodoVariable() {
    var presupuesto = $('#ddlPeriodo').val();
    $("#hdfPeriodo").val(presupuesto);
    var nombrePeriodo = $("#ddlPeriodo option:selected").text();
    $("#hdfNombrePeriodo").val(nombrePeriodo);
}

var listadoActual = [];
function mostrarPanelAdicionPlaneacion() {
    listadoActual = [];
    $('#txtCodigoActividad').focus();
    $('#txtCodigoActividad').val("");
    $('#txtNombreActividad').val("");
    document.getElementById('lblValorUnidad').textContent = "";
    $('#modal45').modal('show');
    var datos = '';
    definicionGridAdicionActividades(datos);
}

function definicionGridAdicionActividades(datos) {
    var info = datos;
    jQuery("#gvActividades").jqGrid("GridUnload");
    var grid = $("#gvActividades").jqGrid({
        datastr: info,
        datatype: 'jsonstring',
        height: '180',
        width: "500",
        rowNum: 1000000,
        multiselect: false,
        ignoreCase: true,
        colNames: ['id', 'Lote', 'Id', 'Actividad', 'Cant Labor', 'Tarifa', 'idTipoPago'],
        colModel: [
    { label: 'id', name: 'id', key: true, hidden: true },
    {
        label: 'lote', name: 'lote', width: 70
    },
    {
        label: 'idActividad', name: 'idActividad', width: 70
    },
    {
        label: 'actividad', name: 'actividad', width: 300
    },
    {
        label: 'cantidadLabor', name: 'cantidadLabor', editable: false, width: 100, formatter: 'number'
    },
    {
        label: 'tarifa', name: 'tarifa', editable: false, width: 70, formatter: 'number'
    },
    {
        label: 'idTipoPago', name: 'idTipoPago', width: 5, hidden: true
    },
        ],
        onSelectRow: function (id) {
            var p = this.p, item = p.data[p._index[id]];
            if (typeof (item.cb) === "undefined") {
                item.cb = true;
            } else {
                item.cb = !item.cb;
            }
        },
        onSelectAll: function (id, status) {
            for (i = 0; i < id.length; i++) {
                var p = this.p, item = p.data[p._index[id[i]]];
                item.cb = status;
            }
        },
        loadComplete: function () {
            var p = this.p, data = p.data, item, $this = $(this), index = p._index, rowid;
            for (rowid in index) {
                if (index.hasOwnProperty(rowid)) {
                    item = data[index[rowid]];
                    if (typeof (item.cb) === "boolean" && item.cb) {
                        $this.jqGrid('setSelection', rowid, false);
                    }
                }
            }
        },
    });
}

function verificarCodigoActividadAdicionar(idCodigoActividad, idNombreActividad, idValorUnidad, listaActividades) {
    var campoCodigoActividad = document.getElementById(idCodigoActividad);
    var campoNombreActividad = document.getElementById(idNombreActividad);
    var campoUnidad = document.getElementById(idValorUnidad);

    //busca el codigo de la actividad en la lista    
    for (i = 0; i < listaActividades.length; i++) {
        if (listaActividades[i].Codigo_Act == campoCodigoActividad.value) {
            campoNombreActividad.value = listaActividades[i].Nombre_Act;
            campoUnidad.textContent = listaActividades[i].Medida_Act;
            obtenerIdTipoPagoActividad(campoCodigoActividad.value)
            return;
        }
    }

    $("#mensajeAdicionar").slideToggle("slow").text("El código de la actividad no es válido o se encuentra inactiva");
    $("#mensajeAdicionar").delay(4000).hide('slow');
    $('#txtCodigoActividad').val("");
    $('#txtNombreActividad').val("");
    document.getElementById('lblValorUnidad').textContent = "";
    campoCodigoActividad.focus();
    return false;
}

function obtenerIdTipoPagoActividad(idActividad) {
    var idTipoPagoActividad = '';
    $.ajax({
        url: "../ServicioValidaciones.asmx/idTipoPagoActividad",
        data: "{idActividad:'" + idActividad + "'}",
        type: "POST",
        dataType: "json",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            idTipoPagoActividad = JSON.parse(result.d);
        },
        error: function (e) {
            $("#mensajeAdicionar").slideToggle("slow").text(JSON.parse(e.responseText).Message);
            $("#mensajeAdicionar").delay(3000).hide('slow');
            $("#mensajeAdicionar").attr("class", "alert fade in alert-danger");
            return false;
        }
    });
    //document.getElementById('hdfIdTipoPago').value = idTipoPagoActividad
    $('#hdfIdTipoPago').val(idTipoPagoActividad);
    console.log(document.getElementById('hdfIdTipoPago').value)
}

function cambioValidacionRadioButton(idRadioButton, idLabelSeleccionado) {
    var campoLabelSeleccionado = document.getElementById(idLabelSeleccionado);
    var valor = $('#' + idRadioButton + ' input[type=radio]:checked').next().html();
    campoLabelSeleccionado.textContent = valor;
    $("#txtRegion").val("");
    $("#txtRegion").focus();
}

function validarOpcionSeleccionadaPlaneacion() {
    var opcion = $("#txtRegion").val().toUpperCase();
    var idRadioButton = document.getElementById("rblOpcion");
    var codigoActividad = $("#txtCodigoActividad").val();
    var tipoAreaPlantacion = $('#rblOpcion ' + 'input[type=radio]:checked').val();
    var valido;
    var mensaje;
    //Casos de validación de la opción
    if (tipoAreaPlantacion == "l") {
        valido = validarActividadAreaPlantacion(opcion, tipoAreaPlantacion, codigoActividad, "mensajeAdicionar");
        mensaje = "El lote " + opcion + " no es válido o se encuentra inactivo";
    } else if (tipoAreaPlantacion == "b") {
        valido = validarActividadAreaPlantacion(opcion, tipoAreaPlantacion, codigoActividad, "mensajeAdicionar");
        mensaje = "El bloque " + opcion + " no es válido para la actividad " + codigoActividad;
    } else if (tipoAreaPlantacion == "s") {
        valido = validarActividadAreaPlantacion(opcion, tipoAreaPlantacion, codigoActividad, "mensajeAdicionar");
        mensaje = "La siembra " + opcion + " no es válida para la actividad " + codigoActividad;
    }
    if (valido == "True") {
        $("#txtRegion").val(opcion);
        $("#txtCantidadLabor").focus();
    } else if (valido == "False") {
        $("#mensajeAdicionar").slideToggle("slow").text(mensaje);
        $("#mensajeAdicionar").delay(3000).hide('slow');
        $("#mensajeAdicionar").attr("class", "alert fade in alert-danger");
        $("#txtRegion").val("");
        $("#txtRegion").focus();
    }
}

function adicionarActividadGrilla() {

    var lista = '';
    var listaDetalles = listadoActual;
    var idActividad = $('#txtCodigoActividad').val();
    var actividad = $('#txtNombreActividad').val();
    var region = $('#txtRegion').val();
    var tipoAreaPlantacion = $('#rblOpcion ' + 'input[type=radio]:checked').val();
    var cantidadLabor = $('#txtCantidadLabor').val();
    var tarifa = $('#txtTarifa').val();
    var idTipoPago = $('#hdfIdTipoPago').val();

    if (idActividad != "") {
        if (region != "") {
            if (cantidadLabor != "") {
                if (tarifa != "") {
                    if (tipoAreaPlantacion == "l") {
                        var detalleNuevo =
                        {
                            "id": 1,
                            "lote": region,
                            "idActividad": idActividad,
                            "actividad": actividad,
                            "cantidadLabor": cantidadLabor.replace(',', '.'),
                            "tarifa": tarifa.replace(',', '.'),
                            "idTipoPago": idTipoPago,
                        };
                        listaDetalles.push(detalleNuevo);
                    } else if (tipoAreaPlantacion == "b") {
                        //Llamar a función ajax para traer los lotes del bloque
                        var bloques = '';
                        $.ajax({
                            url: "../ServicioValidaciones.asmx/listarLotesActivosBloque",
                            data: "{bloque:'" + region + "'}",
                            type: "POST",
                            dataType: "json",
                            async: false,
                            contentType: "application/json; charset=utf-8",
                            success: function (result) {
                                bloques = JSON.parse(result.d);
                            },
                            error: function (e) {
                                $("#mensajeAdicionar").slideToggle("slow").text(JSON.parse(e.responseText).Message);
                                $("#mensajeAdicionar").delay(3000).hide('slow');
                                $("#mensajeAdicionar").attr("class", "alert fade in alert-danger");
                                return false;
                            }
                        });
                        for (j = 0; j < bloques.length; j++) {
                            var detalleNuevo =
                            {
                                "id": 1,
                                "lote": bloques[j].codLote,
                                "idActividad": idActividad,
                                "actividad": actividad,
                                "cantidadLabor": cantidadLabor.replace(',', '.'),
                                "tarifa": tarifa.replace(',', '.'),
                                "idTipoPago": idTipoPago,
                            };
                            listaDetalles.push(detalleNuevo);
                        }
                    } else if (tipoAreaPlantacion == "s") {
                        //Llamar a función ajax para traer los lotes de la siembra
                        var siembra = '';
                        $.ajax({
                            url: "../ServicioValidaciones.asmx/listarLotesActivosSiembra",
                            data: "{siembra:'" + region + "'}",
                            type: "POST",
                            dataType: "json",
                            async: false,
                            contentType: "application/json; charset=utf-8",
                            success: function (result) {
                                siembra = JSON.parse(result.d);
                            },
                            error: function (e) {
                                $("#mensajeAdicionar").slideToggle("slow").text(JSON.parse(e.responseText).Message);
                                $("#mensajeAdicionar").delay(3000).hide('slow');
                                $("#mensajeAdicionar").attr("class", "alert fade in alert-danger");
                                return false;
                            }
                        });
                        for (j = 0; j < siembra.length; j++) {
                            var detalleNuevo =
                            {
                                "id": 1,
                                "lote": siembra[j].codLote,
                                "idActividad": idActividad,
                                "actividad": actividad,
                                "cantidadLabor": cantidadLabor.replace(',', '.'),
                                "tarifa": tarifa.replace(',', '.'),
                                "idTipoPago": idTipoPago,
                            };
                            listaDetalles.push(detalleNuevo);
                        }
                    }

                    lista = JSON.stringify(listaDetalles);
                    definicionGridAdicionActividades(lista);
                    limpiarCamposAdicionActividad();
                }
                else {
                    $("#mensajeAdicionar").slideToggle("slow").text("Ingrese tarifa de la actividad a planear");
                    $("#mensajeAdicionar").delay(3000).hide('slow');
                    $("#mensajeAdicionar").attr("class", "alert fade in alert-danger");
                }
            }
            else {
                $("#mensajeAdicionar").slideToggle("slow").text("Ingrese cantidad de la actividad a planear");
                $("#mensajeAdicionar").delay(3000).hide('slow');
                $("#mensajeAdicionar").attr("class", "alert fade in alert-danger");
            }
        }
        else {
            $("#mensajeAdicionar").slideToggle("slow").text("Ingrese área de la plantación a registrar actividad");
            $("#mensajeAdicionar").delay(3000).hide('slow');
            $("#mensajeAdicionar").attr("class", "alert fade in alert-danger");
        }
    } else {
        $("#mensajeAdicionar").slideToggle("slow").text("Ingrese código de actividad");
        $("#mensajeAdicionar").delay(3000).hide('slow');
        $("#mensajeAdicionar").attr("class", "alert fade in alert-danger");
    }
}

function limpiarCamposAdicionActividad() {
    $('#txtCodigoActividad').val("");
    $('#txtNombreActividad').val("");
    $('#txtRegion').val("");
    $('#txtCantidadLabor').val("");
    $('#txtTarifa').val("");
    $('#hdfIdTipoPago').val("");
    $('#txtCodigoActividad').focus();
}

function adicionarActividad() {
    var idPlanPeriodoEncabezado = $("#txtCodigo").val();
    var sobreEscribir = $("#chkSobreEscribirExistentesAdicionar").is(':checked');

    var listaDetalles = listadoActual;
    var lista = JSON.stringify(listaDetalles);
    $.ajax({
        url: "../ServicioValidaciones.asmx/adicionarDetallesPlanPeriodo",
        data: "{idPlanPeriodoEncabezado:'" + idPlanPeriodoEncabezado + "', listaActividades:'" + lista + "', sobreescribir:'" + sobreEscribir + "'}",
        type: "POST",
        dataType: "json",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            datos = result.d;
        },
        error: function (e) {
            $("#mensajeAdicionar").slideToggle("slow").text("Se han encontrado errores durante la adición de la(s) actividad(es)");
            $("#mensajeAdicionar").delay(3000).hide('slow');
            $("#mensajeAdicionar").attr("class", "alert fade in alert-danger");
            return false;
        }
    });
    if (datos == "true") {
        refrescarGrillaPresupuestoRegistro()
        //recargarActividadesPlanPeriodo()
        $("#hdfIdPresupuestoPlanDetalle").val("");
        listadoActual = [];
        $("#mensajeOperacionesActividades").slideToggle("slow").text("Actividades adicionadas correctamente");
        $("#mensajeOperacionesActividades").delay(5000).hide('slow');
        $("#mensajeOperacionesActividades").attr("class", "alert fade in alert-success");
        $('#modal45').modal('hide');
    }
    else {
        $("#mensajeAdicionar").slideToggle("slow").text("Se han encontrado errores durante la adición de la(s) actividad(es)");
        $("#mensajeAdicionar").delay(3000).hide('slow');
        $("#mensajeAdicionar").attr("class", "alert fade in alert-danger");
        $("#txtErrorAdicionarActividad").html(datos);
        return false;
    }
}

function filaDetalleSeleccionadaPlanPeriodo(args) {
    var grilla = $('#gvsDetalles').data("ejGrid");
    var data = args.data;
    if (data != undefined) {
        $('#hdfIdPresupuestoPlanDetalle').val(data.idPresupuestoPlanDetalle);
        $('#hdfLoteDetalle').val(data.lote);
        $('#hdfIdActividadDetalle').val(data.idActividad);
        $('#hdfActividadDetalle').val(data.actividad);
        $('#hdfTipoPagoDetalle').val(data.idTipoPago);
        var tarifa = data.tarifa.toString();
        var tarifaC = tarifa.replace(".", ",");
        $('#hdfTarifaDetalle').val(tarifaC);
        var cantidadLabor = data.cantidadLabor.toString();
        var cantidadLaborC = cantidadLabor.replace(".", ",");
        $('#hdfCantidadLaborDetalle').val(cantidadLaborC);
        $('#hdfUnidadDetalle').val(data.unidad);
    }
}

function mostrarPanelEliminacionPlaneacion() {
    var id = $('#hdfIdPresupuestoPlanDetalle').val();
    if (id != "") {
        $('#modalConfirmacionEliminacion').modal('show');
        $('#lblMensajeEliminacion').text("Está seguro de eliminar el detalle del plan de periodo de presupuesto");
    } else {
        mostrarMensaje("No se tiene seleccionado un detalle a eliminar");
    }
}

function eliminarDetallePlanPeriodo() {
    //document.getElementById('btnConfirmarEliminacion').disabled = true;
    var idPlanPeriodoEncabezado = $("#txtCodigo").val();
    var idPlanPeriodoDetalle = $("#hdfIdPresupuestoPlanDetalle").val();
    var datos = '';
    $.ajax({
        url: "../ServicioValidaciones.asmx/eliminarDetallePlanPeriodo",
        data: "{idPlanPeriodoEncabezado:'" + idPlanPeriodoEncabezado + "', idPlanPeriodoDetalle:'" + idPlanPeriodoDetalle + "'}",
        type: "POST",
        dataType: "json",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            datos = JSON.parse(result.d);
        },
        error: function (e) {
            $("#mensajeEliminacion").slideToggle("slow").text(JSON.parse(e.responseText).Message);
            $("#mensajeEliminacion").delay(3000).hide('slow');
            $("#mensajeEliminacion").attr("class", "alert fade in alert-danger");
            return false;
        }
    });
    if (datos == true) {
        refrescarGrillaPresupuestoRegistro()
        //recargarActividadesPlanPeriodo()
        $("#mensajeOperacionesActividades").slideToggle("slow").text("Registro eliminado correctamente");
        $("#mensajeOperacionesActividades").delay(3000).hide('slow');
        $("#mensajeOperacionesActividades").attr("class", "alert fade in alert-success");
        $('#modalConfirmacionEliminacion').modal('hide');
        $("#hdfIdPresupuestoPlanDetalle").val("");
    }
    else {
        $("#mensajeEliminacion").slideToggle("slow").text(datos);
        $("#mensajeEliminacion").delay(3000).hide('slow');
        $("#mensajeEliminacion").attr("class", "alert fade in alert-danger");
    }
}


function adicionarImportacionActividades() {
    var listaImportacion = jQuery("#gvActividadesImportacion").getDataIDs();
    //var error = numeroErroresImportacion(lista);
    //Se obtiene la lista de detalles a importar a la planeación del presupuesto
    var listaDetallesImportacion = llenarListaDetallesImportacion(listaImportacion);
    var listadoImportacion = JSON.stringify(listaDetallesImportacion);

}

function mostrarPanelPlantillaPlaneacion() {
    var datos = obtenerInformacionPeriodos();
    definicionGrillaPeriodoActividades(datos, 380, "gvPeriodos");
    document.getElementById('btnDescargarPlantillaPlanPeriodo').disabled = false;
    $('#modal60').modal('show');
    jQuery("#gvTipoActividad").jqGrid("GridUnload");
    var datos = listarTipoActividades();
    definicionGridTipoActividades(datos, 350, "gvTipoActividad");
}

function obtenerInformacionPeriodos() {
    var datos = '';
    var anio = $("#hdfAnio").val();
    $.ajax({
        url: "../ServicioValidaciones.asmx/obtenerInformacionPeriodos",
        type: "POST",
        dataType: "json",
        data: "{anio:'" + anio + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            datos = JSON.parse(result.d);
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
            return false;
        }
    });
    return datos;
}

function definicionGrillaPeriodoActividades(datos, anchoGrid, nombreDivGrid) {
    var info = datos;
    jQuery("#" + nombreDivGrid).jqGrid("GridUnload");
    var grid = $("#" + nombreDivGrid).jqGrid({
        datastr: info,
        datatype: 'jsonstring',
        height: '250',
        width: anchoGrid,
        rowNum: 1000000,
        multiselect: true,
        ignoreCase: true,
        caption: "Periodos",
        colNames: ['Id', 'Periodo'],
        colModel: [
    { label: 'Id', name: 'Id', key: true, hidden: true },
    {
        label: 'Periodo', name: 'Periodo'
    },
        ],
        onSelectRow: function (id) {
            var p = this.p, item = p.data[p._index[id]];
            if (typeof (item.cb) === "undefined") {
                item.cb = true;
            } else {
                item.cb = !item.cb;
            }
        },
        onSelectAll: function (id, status) {
            for (i = 0; i < id.length; i++) {
                var p = this.p, item = p.data[p._index[id[i]]];
                item.cb = status;
            }
        },
        loadComplete: function () {
            var p = this.p, data = p.data, item, $this = $(this), index = p._index, rowid;
            for (rowid in index) {
                if (index.hasOwnProperty(rowid)) {
                    item = data[index[rowid]];
                    if (typeof (item.cb) === "boolean" && item.cb) {
                        $this.jqGrid('setSelection', rowid, false);
                    }
                }
            }
        },
    });
}

function llenarListaPeriodosSeleccionadosPlan(lista) {
    var listaDetalles = [];
    for (j = 0; j < lista.length; j++) {
        row = jQuery("#gvPeriodos").getRowData(lista[j]);
        var detalleNuevo =
        {
            "Id": row.Id,
            "Periodo": row.Periodo,
        };
        listaDetalles.push(detalleNuevo);
    }
    return listaDetalles;
}

function validarDescargarPlantillaPlanPeriodo() {
    //document.getElementById('btnDescargarPlantillaPlanPeriodo').disabled = true;
    var lista = jQuery("#gvPeriodos").getDataIDs();
    var listaPeriodos = llenarListaPeriodosSeleccionadosPlan(lista);
    var listado = JSON.stringify(listaPeriodos);
    var datos = '';

    var periodosSeleccionados;
    var tipoActividadesSeleccionadas;
    var valor = '';
    var valorActividades = '';
    $("#hdfOrden").val('');
    $("#hdfPlantillaVacia").val('');
    var selected = $('#rbtnFiltro input:checked').val();


    var esPlantillaVacia = $("#chkPlantillaVacia").is(':checked');
    //Si no se va a descargar una plantilla vacia se validan los campos
    if (esPlantillaVacia == false) {
        if (selected != undefined) {
            $("#hdfOrden").val(selected);
        } else {
            $("#mensaje").slideToggle("slow").text("Debe seleccionar un filtro para la plantilla");
            $("#mensaje").delay(2000).hide('slow');
            document.getElementById('btnDescargarPlantillaPlanPeriodo').disabled = false;
            return false;
        }

        periodosSeleccionados = jQuery("#gvPeriodos").jqGrid('getGridParam', 'selarrrow');
        if (periodosSeleccionados.length > 0) {
            for (i = 0; i < periodosSeleccionados.length; i++) {
                var datoFilaSeleccionada = jQuery('#gvPeriodos').jqGrid('getRowData', periodosSeleccionados[i]);
                var id = datoFilaSeleccionada.Id;
                valor = valor + id + ',';
            }
            $("#hdfIdPeriodos").val(valor);
        } else {
            $("#mensaje").slideToggle("slow").text("Debe seleccionar al menos un periodo");
            $("#mensaje").delay(2000).hide('slow');
            document.getElementById('btnDescargarPlantillaPlanPeriodo').disabled = false;
            return false;
        }

        tipoActividadesSeleccionadas = jQuery("#gvTipoActividad").jqGrid('getGridParam', 'selarrrow');
        if (tipoActividadesSeleccionadas.length > 0) {
            for (i = 0; i < tipoActividadesSeleccionadas.length; i++) {
                var datoFilaSeleccionadaAct = jQuery('#gvTipoActividad').jqGrid('getRowData', tipoActividadesSeleccionadas[i]);
                var id = datoFilaSeleccionadaAct.Id;
                valorActividades = valorActividades + id + ',';
            }
            $("#hdfIdTipoActividades").val(valorActividades);
        } else {
            $("#mensaje").slideToggle("slow").text("Debe seleccionar al menos un tipo de actividad");
            $("#mensaje").delay(2000).hide('slow');
            document.getElementById('btnDescargarPlantillaPlanPeriodo').disabled = false;
            return false;
        }
    } else {
        $("#hdfIdPeriodos").val('');
        $("#hdfIdTipoActividades").val('');
    }
    blockUIForDownload()
}

function edicionActividad() {
    var id = $('#hdfIdPresupuestoPlanDetalle').val();
    if (id != "") {

    } else {
        mostrarMensaje("No se tiene seleccionado un detalle a editar");
    }
}

function refrescarGrillaActividadesPlanPeriodo() {
    var gridObj = $("#gvsDetalles").data("ejGrid");
    gridObj.refreshContent();
}

function mostrarPanelImportacionDatos() {
    try {
        var datos = obtenerInformacionPeriodos();
        definicionGrillaPeriodoActividades(datos, 425, "gvPeriodosImportacion");
        jQuery("#gvTipoActividadImportacion").jqGrid("GridUnload");
        var datos = listarTipoActividades();
        definicionGridTipoActividades(datos, 425, "gvTipoActividadImportacion");
        //var datos = obtenerActividadesDesdePresupuesto();
        //definicionGridImportacionActividades(datos);

        //Mostrar información en Textbox del panel de importación
        var idPresupuestoEncabezado = $('#ddlEscenario').val();
        var idPresupuestoPeriodo = $('#ddlPeriodo').val();
        $('#txtIdEscenarioPpto').val(idPresupuestoEncabezado);
        $('#txtEscenarioPpto').val($("#ddlEscenario option:selected").text())
        $('#txtIdPeriodoPpto').val(idPresupuestoPeriodo)
        $('#txtPeriodoPpto').val($("#ddlPeriodo option:selected").text())
        $('#txtAnioPpto').val($('#hdfAnio').val())
        $('#txtErrorCargueArchivo').val("");
        $('#modal70').modal('show');
    } catch (e) {
        return false;
    }
}

function operacionesImportacionPlanPeriodo() {
    var valor = $('#rblOpcionesImportacion input:checked').val();
    if (valor == "pre") {
        importarActividadesPlanPeriodo();
    } else if (valor == "pla") {
        subirArchivoPlantillaPlanPeriodo();
    }
}

function importarActividadesPlanPeriodo() {
    var idPlanPeriodoEncabezado = $("#txtCodigo").val();
    var sobreEscribir = $('#chkSobreEscribirExistentes').is(":checked");
    var limpiar = $('#chkLimpiarExistentes').is(":checked");

    var valorPeriodos = '';
    var valorActividades = '';
    var periodosSeleccionados = jQuery("#gvPeriodosImportacion").jqGrid('getGridParam', 'selarrrow');
    if (periodosSeleccionados.length > 0) {
        for (i = 0; i < periodosSeleccionados.length; i++) {
            var datoFilaSeleccionada = jQuery('#gvPeriodosImportacion').jqGrid('getRowData', periodosSeleccionados[i]);
            var id = datoFilaSeleccionada.Id;
            valorPeriodos = valorPeriodos + id + ',';
        }
    } else {
        $("#mensajeImportarPresupuesto").slideToggle("slow").text("Debe seleccionar al menos un periodo");
        $("#mensajeImportarPresupuesto").delay(3000).hide('slow');
        $("#mensajeImportarPresupuesto").attr("class", "alert fade in alert-danger");
        return false;
    }

    tipoActividadesSeleccionadas = jQuery("#gvTipoActividadImportacion").jqGrid('getGridParam', 'selarrrow');
    if (tipoActividadesSeleccionadas.length > 0) {
        for (i = 0; i < tipoActividadesSeleccionadas.length; i++) {
            var datoFilaSeleccionadaAct = jQuery('#gvTipoActividadImportacion').jqGrid('getRowData', tipoActividadesSeleccionadas[i]);
            var id = datoFilaSeleccionadaAct.Id;
            valorActividades = valorActividades + id + ',';
        }
    } else {
        $("#mensajeImportarPresupuesto").slideToggle("slow").text("Debe seleccionar al menos un tipo de actividad");
        $("#mensajeImportarPresupuesto").delay(3000).hide('slow');
        $("#mensajeImportarPresupuesto").attr("class", "alert fade in alert-danger");
        return false;
    }

    if (valorPeriodos != "") {
        if (valorActividades != "") {
            var datos = '';
            $.ajax({
                url: "../ServicioValidaciones.asmx/importarActividadesDesdePresupuesto",
                data: "{idPlanPeriodoEncabezado:'" + idPlanPeriodoEncabezado + "', listaIdPeriodos:'" + valorPeriodos + "', listaIdTipoActividades:'" + valorActividades + "', sobreescribirRegistros:'" + sobreEscribir + "', limpiarExistentes:'" + limpiar + "'}",
                type: "POST",
                dataType: "json",
                async: false,
                contentType: "application/json; charset=utf-8",
                success: function (result) {
                    datos = result.d;
                },
                error: function (e) {
                    $("#mensajeImportarPresupuesto").slideToggle("slow").text("Se han encontrado errores durante la carga de actividades");
                    $("#mensajeImportarPresupuesto").delay(3000).hide('slow');
                    $("#mensajeImportarPresupuesto").attr("class", "alert fade in alert-danger");
                    $("#txtErrorCargueDesdePpto").html(datos);
                    return false;
                }
            });

            console.log(datos);
            if (datos == "true") {
                refrescarGrillaActividadesPlanPeriodo();
                $("#mensajeOperacionesActividades").slideToggle("slow").text("Actividades cargadas correctamente");
                $("#mensajeOperacionesActividades").delay(5000).hide('slow');
                $("#mensajeOperacionesActividades").attr("class", "alert fade in alert-success");
                $('#modal70').modal('hide');
            }
            else {
                $("#mensajeImportarPresupuesto").slideToggle("slow").text(datos);
                $("#mensajeImportarPresupuesto").delay(3000).hide('slow');
                $("#mensajeImportarPresupuesto").attr("class", "alert fade in alert-danger");
                return false;
            }
        }
        else {
            $("#mensajeImportarPresupuesto").slideToggle("slow").text("Debe seleccionar al menos un tipo de actividad");
            $("#mensajeImportarPresupuesto").delay(3000).hide('slow');
            $("#mensajeImportarPresupuesto").attr("class", "alert fade in alert-danger");
            return false;
        }
    } else {
        $("#mensajeImportarPresupuesto").slideToggle("slow").text("Debe seleccionar al menos un periodo");
        $("#mensajeImportarPresupuesto").delay(3000).hide('slow');
        $("#mensajeImportarPresupuesto").attr("class", "alert fade in alert-danger");
        return false;
    }
}


function subirArchivoPlantillaPlanPeriodo() {

    var data = new FormData();
    var sobreEscribir = $('#chkSobreEscribirExistentes').is(":checked");
    var limpiar = $('#chkLimpiarExistentes').is(":checked");
    var idPlanPeriodo = $('#txtCodigo').val();
    var files = $("#fupSubirPlaneacion").get(0).files;
    // Si se tiene archivo se va a guardar
    if (files.length > 0) {
        data.append("ArchivosPlaneacion", files[0]);
    }
    data.append("sobreEscribir", sobreEscribir);
    data.append("limpiar", limpiar);
    data.append("idPlanPeriodo", idPlanPeriodo);
    var ruta = '';
    // Make Ajax request with the contentType = false, and procesDate = false
    var ajaxRequest = $.ajax({
        type: "POST",
        url: "../ServicioValidaciones.asmx/subirArchivoPlantillaPlanPeriodo",
        contentType: false,
        processData: false,
        data: data,
        success: function (result) {
        },
    });
    ajaxRequest.done(function (xhr, textStatus) {
        $("#fupSubirPlaneacion").replaceWith($("#fupSubirPlaneacion").clone());
        console.log(textStatus)
        if (textStatus == "success") {
            refrescarGrillaActividadesPlanPeriodo();
            $("#mensajeOperacionesActividades").slideToggle("slow").text("Actividades cargadas correctamente");
            $("#mensajeOperacionesActividades").delay(5000).hide('slow');
            $("#mensajeOperacionesActividades").attr("class", "alert fade in alert-success");
            $('#modal70').modal('hide');
        }
    });
    ajaxRequest.fail(function (xhr, textStatus, errorThrown) {
        $("#fupSubirPlaneacion").replaceWith($("#fupSubirPlaneacion").clone());
        var error = xhr.responseText;
        error = error.replace(/(\r\n|\n|\r)/gm, "");
        $("#txtErrorCargueArchivo").html(error);
        $("#mensajeImportarPlantilla").slideToggle("slow").text("Se han presentado errores en el documento a cargar");
        $("#mensajeImportarPlantilla").delay(10000).hide('slow');
        $("#mensajeImportarPlantilla").attr("class", "alert fade in alert-danger");
    });
}

/**************************** Desviaciones ****************************/

function personalizarCeldas(args) {
    var value = args.text.replace(",", "");
    var $element = $(args.cell);
    switch (args.column.field) {
        case "estado":
            if (value == "Pendiente") {
                $element.css("background-color", "#E94649").css("color", "#FFF");
            } else if (value == "Justificado") {
                $element.css("background-color", "#71D25F").css("color", "#FFF");
            }
            break;
        case "PorcentVariacionCosto":
            if (parseFloat(value) < 0) {
                $element.css("color", "red").prepend("<img src='../images/down.png' height='15px' width='13px' style='padding-left:1px; float:right;' ></img> ");
            } else if (parseFloat(value) > 0) {
                $element.css("color", "green").prepend("<img src='../images/up.png' height='15px' width='13px' style='padding-left:1px; float:right;' ></img> ");
            }
            else if (parseFloat(value) == 0) {
                $element.css("color", "gray").prepend("<img src='../images/neutral.png' height='15px' width='13px' style='padding-left:1px; float:right;' ></img> ");
            }
            break;
        case "PorcentVariacionLabor":
            if (parseFloat(value) < 0) {
                $element.css("color", "red").prepend("<img src='../images/down.png' height='15px' width='13px' style='padding-left:1px; float:right;' ></img> ");
            } else if (parseFloat(value) > 0) {
                $element.css("color", "green").prepend("<img src='../images/up.png' height='15px' width='13px' style='padding-left:1px; float:right;' ></img> ");
            }
            else if (parseFloat(value) == 0) {
                $element.css("color", "gray").prepend("<img src='../images/neutral.png' height='15px' width='13px' style='padding-left:1px; float:right;' ></img> ");
            }
            break;
    }
}

function mostrarInformacionEdicionDesviaciones(divMensaje, mensaje, valor) {
    if (divMensaje == "mensajeDesviacionPPTOGeneral") {
        $("#mensajeDesviacionPPTOGeneral").slideToggle("slow").text(mensaje);
        $("#mensajeDesviacionPPTOGeneral").delay(3000).hide('slow');
        if (valor == "1") {
            $("#mensajeDesviacionPPTOGeneral").attr("class", "alert fade in alert-success");
        } else {
            $("#mensajeDesviacionPPTOGeneral").attr("class", "alert fade in alert-danger");
        }
    } else if (divMensaje == "mensajeDesviacionEjecutadoGeneral") {
        $("#mensajeDesviacionEjecutadoGeneral").slideToggle("slow").text(mensaje);
        $("#mensajeDesviacionEjecutadoGeneral").delay(3000).hide('slow');
        if (valor == "1") {
            $("#mensajeDesviacionEjecutadoGeneral").attr("class", "alert fade in alert-success");
        } else {
            $("#mensajeDesviacionEjecutadoGeneral").attr("class", "alert fade in alert-danger");
        }
    }
}

function filaDesviacionPPTO(args) {
    var grilla = $('#gvsDesviacionPPTO').data("ejGrid");
    var data = args.data;
    console.log(data);
    if (data != undefined) {
        $('#hdfIdDesvPpto').val(data.idDesviacionPresupuestado);
        $('#hdfIdPresupuestoDesvioCategoriaPpto').val(data.idCategoria);
        $('#hdfIdPresupuestoDesvioMotivoPpto').val(data.idMotivo);
        $('#hdfIdActividadDesvPpto').val(data.idActividad);
        $('#hdfIdLoteDesvPpto').val(data.idLote);
        $('#hdfActividadDesvPpto').val(data.actividad);
        $('#hdfMotivoDesvPpto').val(data.motivo);
    }
}

function guardarMotivoPPTOVariable() {

    var categoriaPPTO = $('#ddlMotivoPPTO').val();
    console.log(categoriaPPTO);
    $("#hdfIdPresupuestoDesvioMotivoPpto").val(categoriaPPTO);
}

function cargarMotivosPPTO(id) {
    var idCategoria = $('#ddlCategoriaPPTO').val();
    $.ajax({
        type: "POST",
        url: "../ServicioValidaciones.asmx/cargarMotivosCategoria",
        data: "{idCategoria: '" + idCategoria + "'}",
        contentType: "application/json; charset=utf-8",
        dataType: "json",
        success: function (response) {
            document.getElementById('ddlMotivoPPTO').innerHTML = "";
            var models = (typeof response.d) == 'string' ? eval('(' + response.d + ')') : response.d;
            if (models.length > 0) {
                adicionarOpcion("--Seleccione--", 0, "ddlMotivoPPTO");
                for (var i = 0; i < models.length; i++) {
                    var val = models[i].idPresupuestoDesvioMotivo;
                    var text = models[i].nombre;
                    adicionarOpcion(text, val, "ddlMotivoPPTO");
                }
            } else {
                adicionarOpcion("--Seleccione--", 0, "ddlMotivoPPTO");
            }
        }
    });
}

function filaDesviacionEjecutado(args) {
    var grilla = $('#gvsDesviacionEjecutado').data("ejGrid");
    var data = args.data;
    if (data != undefined) {
        $('#hdfIdDesvEjecutado').val(data.idDesviacionEjecutado);
        $('#hdfIdPresupuestoDesvioCategoriaEjecutado').val(data.idCategoria);
        $('#hdfIdPresupuestoDesvioMotivoEjecutado').val(data.idMotivo);
        $('#hdfIdActividadDesvEjecutado').val(data.idActividad);
        $('#hdfIdLoteDesvEjecutado').val(data.idLote);
        $('#hdfActividadDesvEjecutado').val(data.actividad);
        $('#hdfMotivoDesvEjecutado').val(data.motivo);
    }
}

function guardarMotivoEjecutadoVariable() {
    var categoriaPPTO = $('#ddlMotivoEjecutado').val();
    $("#hdfIdPresupuestoDesvioMotivoEjecutado").val(categoriaPPTO);
}

function cargarMotivosEjecutado(id) {
    var idCategoria = $('#ddlCategoriaEjecutado').val();
    $.ajax({
        type: "POST",
        url: "../ServicioValidaciones.asmx/cargarMotivosCategoria",
        data: "{idCategoria: '" + idCategoria + "'}",
        contentType: "application/json; charset=utf-8",
        dataType: "json",
        success: function (response) {
            document.getElementById('ddlMotivoEjecutado').innerHTML = "";
            var models = (typeof response.d) == 'string' ? eval('(' + response.d + ')') : response.d;
            if (models.length > 0) {
                adicionarOpcion("--Seleccione--", 0, "ddlMotivoPPTO");
                for (var i = 0; i < models.length; i++) {
                    var val = models[i].idPresupuestoDesvioMotivo;
                    var text = models[i].nombre;
                    adicionarOpcion(text, val, "ddlMotivoEjecutado");
                }
            } else {
                adicionarOpcion("--Seleccione--", 0, "ddlMotivoEjecutado");
            }
        }
    });
}
/******************************************************** Fin Planeación ********************************************************/


function personalizarCeldasInformeCierre(args) {
    console.log("entro");
    var value = args.text.replace(",", "");
    var $element = $(args.cell);
    console.log(value);
    var rutaRaiz = '../../images';
    switch (args.column.field) {
        case "porcentVariCantLabor":
            if (parseFloat(value) < 0) {
                $element.css("color", "red").prepend("<img src='"+ rutaRaiz+"/down.png' height='15px' width='13px' style='padding-left:1px; float:right;' ></img> ");
            } else if (parseFloat(value) > 0) {
                $element.css("color", "green").prepend("<img src='" + rutaRaiz + "/up.png' height='15px' width='13px' style='padding-left:1px; float:right;' ></img> ");
            }
            else if (parseFloat(value) == 0) {
                $element.css("color", "gray").prepend("<img src='" + rutaRaiz + "/neutral.png' height='15px' width='13px' style='padding-left:1px; float:right;' ></img> ");
            }
            break;
        case "porcentVariCosto":
            if (parseFloat(value) < 0) {
                $element.css("color", "red").prepend("<img src='" + rutaRaiz + "/down.png' height='15px' width='13px' style='padding-left:1px; float:right;' ></img> ");
            } else if (parseFloat(value) > 0) {
                $element.css("color", "green").prepend("<img src='" + rutaRaiz + "/up.png' height='15px' width='13px' style='padding-left:1px; float:right;' ></img> ");
            }
            else if (parseFloat(value) == 0) {
                $element.css("color", "gray").prepend("<img src='" + rutaRaiz + "/neutral.png' height='15px' width='13px' style='padding-left:1px; float:right;' ></img> ");
            }
            break;
    }
}